/*
 TODO:
  * COPY
      Needs more testing.
  * GODIR
      Needs more testing also.
  * IF EXISTS
      Should work, might need more testing.
  * IF ERRORLEVEL
      Probably doesn't work worth a damn haha.
  * TESTDIR
      Nothing in my collection seems to use this, but its behavior is known.

Not gonna do these:
  * SIP file support
  * "Make boot disk" option
      Original install displays file list, if any, for confirmation and explains what to tell FORMAT.COM.
      Need to see what the final result looks like...
      Doesn't seem worth it, really?
  * Match observed behavior:
      1) Go through all DRV files in path.
      2) Read the 8th byte to tell what type it is.
      3) Look up the name.
         A) INSTALL whines and stops if it can't find the name in INSTALL.HLP.
            We can, instead, show "Unknown (%s)", or read the driver's internal name.
      4) Append driver data to the correct list.

DA FINE GUIDE
  -DNORTON
      Bright backgrounds, custom borders...
  -DMEINLEBEN
      Disables SB/AdLib detection via hardware I/O in favor of checking BLASTER.
  -DNOJOY
      Disables joystick selection. Who has those nowadays?
  -DLANGUAGEPACKS
      Enables detection and selection of language packs.

Made in Turbo C++ 3.0 ==> https://winworldpc.com/product/turbo-c/3x
Suggested build command line:
   tcc -DNORTON -1 -d -f87 -O install.c
   (80186 opcodes, fold strings, 8087 float ops, optimize jumps)

*/

#include <conio.h>
#include <ctype.h>
#include <dir.h>
#include <dirent.h>
#include <dos.h>
#include <process.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>

/*********************************************************
 * TEXT
 *********************************************************/

#define RESCFG "RESOURCE.CFG"
#define SCRIPT "INSTALL.SCR"

#ifndef NORTON
	#define CP "(C)"
	#define TM ""
	#define RT ""
	#define EUR "EUR "
#else
	#define CP "\xB8"
	#define TM "\xAA"
	#define RM "\xA9"
	#define EURO "\xF5"
#endif

#define TEXT_TOPWINDOW \
	"   Firrhna Productions\n" \
	"Game Setup Program v1.3"
#define TEXT_BOTTOMWINDOW CP " 2023 Firrhna Productions"

#define TEXT_INTRO_CAPTION "Welcome"
#define TEXT_INTRO \
	"This program will let you specify what type of " \
	"hardware is installed in your machine.\n" \
	"\n" \
	"You must run it once before playing your Firrhna " \
	"Productions game.  You may want to run it again if you " \
	"add new hardware to your system or if you are having " \
	"problems with your first selections."

#define TEXT_MAINMENU_CAPTION "Main Menu"
#define TEXT_MAINMENU \
	"If you want to change any of these choices, use \x18 and \x19 to " \
	"highlight the selection, then press ENTER."
#define TEXT_MAINMENU_GRAPHICS "Graphics  : "
#define TEXT_MAINMENU_MUSIC    "Music     : "
#define TEXT_MAINMENU_AUDIO    "Audio     : "
#define TEXT_MAINMENU_JOYSTICK "Joystick  : "
#define TEXT_MAINMENU_KEYBOARD "Keyboard  : "
#define TEXT_MAINMENU_MOUSE    "Mouse     : "
#define TEXT_MAINMENU_MEMORY   "Memory    : "
#define TEXT_MAINMENU_LANGUAGE "Language  : "
#define TEXT_MAINMENU_DIRECTORY"Directory : %c:%s"
#define TEXT_MAINMENU_README   "   View documentation update in README file"
#define TEXT_MAINMENU_BOOTDISK "   Make bootable floppy disk"
#define TEXT_MAINMENU_ACCEPT   "   Accept these choices and save configuration"
#define TEXT_MAINMENU_INSTALL  "   Accept these choices and begin installation"
#define TEXT_MAINMENU_DEFAULT  "   Restore default choices"
#define TEXT_MAINMENU_CANCEL   "   Cancel installation and return to DOS"

#define TEXT_DRIVER_VIDEO	   "Select a graphics adapter from the choices below"
#define TEXT_DRIVER_MUSIC      "Select a music card from the choices below"
#define TEXT_DRIVER_AUDIO      "Select a speech/sound effects card from the choices below.\nNOTE: Not all games support speech."
#define TEXT_DRIVER_JOYSTICK   "Select the type of joystick you have"
#define TEXT_DRIVER_KEYBOARD   "Select which style of keyboard you have"
#define TEXT_DRIVER_MOUSE      "Select whether you will use a mouse"
#define TEXT_DRIVER_MEMORY     "Do you want to use expanded, extended and/or XMS memory?"
#define TEXT_LANGUAGE          "Select a language pack."

#define TEXT_SELECT_DRIVE_TITLE "Target drive"
#define TEXT_SELECT_DRIVE "Choose a drive to install to from the drives shown below."
#define TEXT_SELECT_DRIVE_FORMAT "  %c:   %6.1f M free"
#define TEXT_SELECT_DRIVE_NOSPACE "There are no hard drives available with enough free space."
#define TEXT_SELECT_DIR_TITLE "Target directory"
#define TEXT_SELECT_DIR "Enter directory where game will be installed"
#define TEXT_SELECT_DIR_PROMPT "Directory %s:"

#define TEXT_EXIT "Do you wish to exit?"
#define TEXT_NORESCFG "No RESOURCE.CFG found. Using defaults."
#define TEXT_CANTWRITE "Could not open configuration file for writing."

#define TEXT_WARNING_TITLE "Warning"
#define TEXT_README_TITLE "Read Me"
#define TEXT_BUTTON_CONTINUE "  Continue  "
#define TEXT_BUTTON_CANCEL   "  Cancel  "
#define TEXT_BUTTON_YES      "  Yes  "
#define TEXT_BUTTON_NO       "  No  "
#define TEXT_BUTTON_CONTINUE_WIDTH 12
#define TEXT_BUTTON_CANCEL_WIDTH   10
#define TEXT_BUTTON_YES_WIDTH      7
#define TEXT_BUTTON_NO_WIDTH       6
#define MIN_BUTTON_WIDTH 2 + TEXT_BUTTON_CONTINUE_WIDTH + 2 + TEXT_BUTTON_CANCEL_WIDTH + 2

#define TEXT_SCRIPT_COPYING   "Copying %s..."
#define TEXT_SCRIPT_COPYINGTO "Copying %s to %s..."
#define TEXT_SCRIPT_ADDINGTO  "Adding %s to %s..."
#define TEXT_SCRIPT_CANTFINDINPUT  "Can't find input file: %s"
#define TEXT_SCRIPT_CANTOPENOUTPUT "Can't open output file: %s"
#define TEXT_SCRIPT_CANTMAKEOUTPUT "Can't create output file: %s"
#define TEXT_SCRIPT_PRESSANYKEY "Press any key to continue..."
#define TEXT_SCRIPT_ERROR "Script error"
#define TEXT_SCRIPT_NO_COPY_FROM "ScriptCopy: No 'from' given, can't copy nothing."
#define TEXT_SCRIPT_NO_ERRORLEVEL "IF ERRORLEVEL unimplemented."
#define TEXT_SCRIPT_DOUBLE_SPACE "The SPACE script command is not supported if you have a 'space=' line in your RESOURCE.CFG, since in that case you should let the Install program itself determine if enough space is available."

#define TEXT_RESTOREDDEFAULTS "Restored %s to defaults.\n"
#define TEXT_USAGE \
	"Usage: install [FILE] [OPTION]...\n" \
	"FILE defaults to RESOURCE.CFG.\n" \
	"Example: install game.cfg -s -f\n" \
	"\n" \
	"  -r\treset to defaults and exit\n" \
	"  -n\tno intro\n" \
	"  -s\tskip Sound Blaster detection\n" \
	"  -f\tforce CGA compatibility\n" \
	"\n" \
	"Report bugs to: kawaoneechan@gmail.com\n"


// //-mark: "supported" in DOSBox
#define DRIVER_VGA320   "VGA or IBM PS/2 - 256 colors" //
#define DRIVER_VGA320BW "VGA or IBM PS/2 - grayscale" //
#define DRIVER_EGA320   "EGA/VGA - 16 colors"
#define DRIVER_EGA640   "EGA/VGA - 16 colors dithered" //
#define DRIVER_MCGA320  "MCGA - 16/256 colors"
#define DRIVER_TANDY320 "Tandy 1000, RGB monitor - 16 colors"
#define DRIVER_EXPLORER "Explorer, RGB monitor - 16 colors"
#define DRIVER_PCJR320  "PCjr, RGB or composite - 16 colors"
#define DRIVER_CGA320M  "CGA, RGB monitor - black and white"
#define DRIVER_CGA320C  "CGA, RGB monitor - 4 colors"
#define DRIVER_HERCMONO "Hercules 720x348 - monochrome" //if DOSBox' machine = cga

#define DRIVER_MTPRO    "Roland MT-32 with Pro Audio Spectrum"
#define DRIVER_MTBLAST  "Roland MT-32 with Sound Blaster"
#define DRIVER_MT32     "Roland MT-32, MT-100, LAPC-I, CM-32L, or CM-64" //
#define DRIVER_GENMIDI  "General MIDI sound driver"
#define DRIVER_GENMIDMV "General MIDI for MediaVision"
#define DRIVER_PROAUDIO "Pro Audio Spectrum"
#define DRIVER_FB01     "Yamaha FB-01 FM sound generator"
#define DRIVER_SNDBLAST "Sound Blaster card"
#define DRIVER_ADL      "Sound Blaster / AdLib card" //
#define DRIVER_OPL2LPT	"OPL2LPT AdLib device" //
#define DRIVER_MICROSOF "Microsoft Windows Sound System"
#define DRIVER_SBPRO    "Sound Blaster Pro" //
#define DRIVER_CMS      "Game Blaster card"
#define DRIVER_TANDY3VD "Tandy 3 Voice with DAC"
#define DRIVER_TANDY3V  "Tandy 3 Voice"
#define DRIVER_IBMPS1   "IBM PS/1 Audio/Joystick card"
#define DRIVER_IMF      "IBM Music Feature card"
#define DRIVER_MT540    "Casiotone MT-540 or CT-460"
#define DRIVER_STD      "IBM PC internal speaker" //
#define DRIVER_NOLOAD   "MT-32 NoLoad Driver (not for shipping)" //
#define DRIVER_MIDNONE  "No music card" //

#define DRIVER_AUDPS1   "IBM PS/1"
#define DRIVER_AUDTANDY "Tandy with DAC"
#define DRIVER_AUDPRO   "Pro Audio Spectrum"
#define DRIVER_AUDPRO16 "Pro Audio Spectrum 16"
#define DRIVER_AUDBLAST "Sound Blaster" //
#define DRIVER_AUDTHUND "ThunderBoard" //
#define DRIVER_AUDMSSYS "Microsoft Windows Sound System"
#define DRIVER_AUDDISNY "Disney Sound Source" //
#define DRIVER_AUDNONE  "No audio/voice card" //

#define DRIVER_IBMKBD   "IBM or compatible keyboard"
#define DRIVER_TANDYKBD "Tandy 1000 keyboard"

#define DRIVER_JOYSTICK "IBM or compatible joystick"
#define DRIVER_SUPER    "Tandy Super Joystick"
#define DRIVER_NOJOY    "Don't use a joystick" //

#define DRIVER_STDMOUSE "Use Microsoft compatible mouse" //
#define DRIVER_NOMOUSE  "Don't use a mouse"

#define DRIVER_ARM      "Use your machine's extra memory" //
#define DRIVER_NOMEMORY "Don't use extra memory"

//We're using \xFF to trick the wrapper into not flushing left.
#define DRIVER_MT32_NOTE \
	"Before running your game, be sure to:\n" \
	"1.  Make sure the module is connected to your MIDI\n" \
	"\xFF   computer port and an external amplifier or\n" \
	"\xFF   stereo or powered speakers.\n" \
	"2.  Set the volume of your stereo to a moderate\n" \
	"\xFF   listening level.\n" \
	"\n" \
	"WARNING:  THE MIDI SOUND DRIVER WILL WRITE NEW\n" \
	"\xFF         SOUNDS INTO YOUR MT-32.  IF YOU ARE USING\n" \
	"\xFF         YOUR SOUND MODULE FOR COMPOSING AS WELL\n" \
	"\xFF         AS PLAYING GAMES, AND HAVE LOADED SPECIAL\n" \
	"\xFF         SOUNDS THAT YOU WANT TO KEEP, BACK THEM\n" \
	"\xFF         UP BEFORE RUNNING THE GAME.\n" \
	"\xFF         (This driver writes to unit #17)"
#define DRIVER_GENMIDI_NOTE \
	"Before running your game, be sure to:\n" \
	"1.  Make sure the module is connected to your MIDI\n" \
	"\xFF   computer port and an external amplifier or\n" \
	"\xFF   stereo or powered speakers.\n" \
	"2.  Set the volume of your stereo to a moderate\n" \
	"\xFF   listening level."
#define DRIVER_JOYSTICK_NOTE \
	"Please ensure that the joystick is centered when " \
	"you start the game."
#define DRIVER_TANDYKBD_NOTE \
	"Make certain that NUMLOCK is ON if you wish to " \
	"use your numeric keypad to control your character."
#define DRIVER_ARM_NOTE \
	"To use EXTENDED memory, you must make sure you have " \
	"no other memory-resident programs loaded that use " \
	"extended memory, such as RAM disks or disk caches.\n" \
	"\n" \
	"To use EXPANDED memory, your EMS driver software " \
	"must be loaded before you start the game.\n" \
	"\n" \
	"To use XMS memory, your XMS driver must be loaded " \
	"before you start the game.\n" \
	"\n" \
	"NOTE:  Not all machines support our use of extended " \
	"memory.  If your computer locks up or otherwise " \
	"exhibits undesirable behavior while playing the " \
	"game, try reinstalling without selecting this option."

/*********************************************************
 * SCHEME
 *********************************************************/

#ifndef NORTON
	#define BACK_COLOR 0x19
	#define BACK_CHAR 0xB1
	#define TOP_LINE 0xCD
	#define BOT_LINE 0xCD
	#define LEFT_LINE 0xB3
	#define RIGHT_LINE 0xB3
	#define TOP_LEFT 0xD5
	#define TOP_RIGHT 0xB8
	#define BOT_LEFT 0xD4
	#define BOT_RIGHT 0xBE
	#define README_COLOR 0x3F
	#define README_TEXT_COLOR 0x30
	#define CORNER_COLOR 0x30
	#define MESSAGE_COLOR 0x2F
	#define CONFIRM_COLOR 0x4E
	#define MENU_COLOR 0x1F
	#define SELECT_COLOR 0x70
	#define SHADOW_COLOR 0x08
	#define BUTTON_NORMAL 0x30
	#define BUTTON_FOCUS 0x3E
	#define BUTTON_NORMAL_EGA 0x30
	#define BUTTON_FOCUS_EGA 0x3E
	#define TITLE_LEFT 0xB5
	#define TITLE_RIGHT 0xC6
#else
	#define BACK_COLOR 0x19
	#define BACK_CHAR 0xB1
	#define TOP_LINE 0xC1
	#define BOT_LINE 0xCD
	#define LEFT_LINE 0xB9
	#define RIGHT_LINE 0xD9
	#define TOP_LEFT 0xC9
	#define TOP_RIGHT 0xC2
	#define BOT_LEFT 0xCC
	#define BOT_RIGHT 0xC8
	#define README_COLOR 0x3F
	#define README_TEXT_COLOR 0x30
	#define CORNER_COLOR 0xB0
	#define MESSAGE_COLOR 0x2F
	#define CONFIRM_COLOR 0x4E
	#define MENU_COLOR 0x9F
	#define SELECT_COLOR 0xF0
	#define SHADOW_COLOR 0x08
	#define BUTTON_NORMAL 0x70
	#define BUTTON_FOCUS 0xF1
	#define BUTTON_NORMAL_EGA 0x30
	#define BUTTON_FOCUS_EGA 0x3E
	#define TITLE_LEFT 0xB5
	#define TITLE_RIGHT 0xC6
#endif

/*********************************************************
 * INTERFACE
 *********************************************************/

//Pointer to video RAM, used for both text and (in Norton mode) graphics.
volatile char far* vidya = (volatile char far*)0xB8000000l;
int VGALevel;

#define MAXLISTITEMS 32
#define MAXLISTSHOWN 10
//Consider making this like 32 and adding scroll support.
//Might be good if/when SCI2/3 DAC*. and Gravis drivers are added to the list.
//Sierra's list shows only 13 items, no indication of scrollability.

typedef struct menuList
{
	int count;
	int active;
	int wantChecks;
	char* title;
	char* headText;
	char* items[MAXLISTITEMS];
	int keys[MAXLISTITEMS];
	int check[MAXLISTITEMS];
} menuList;

char wrapBuffer[1024] = { 0 };

void ClearScreen();
void Window(int left, int top, int width, int height, const char* title, int colors);
void SetAttr(int left, int top, int width, int color);
void Text(int left, int top, const char* text);
int Message(const char* message, const char* title, int colors);
int DoMenu(menuList* list);
void Exit(int ret);

char* Wrap(const char *s, int lineSize);

#define MESSAGE_ENTERORESC 0x100
#define MESSAGE_YESORNO 0x200

/*********************************************************
 * DRIVERS
 *********************************************************/

typedef struct sDriver
{
	char* file;
	char* name;
	char flags;
	char* warning;
} sDriver;

#define D_DEFAULT 1 //Consider as a default choice.

#ifndef NOJOY
#define NUMDRIVERS 50
#else
#define NUMDRIVERS 42
#endif
//keep that up to date.
const sDriver drivers[NUMDRIVERS] =
{
	{ 0, 0, 0, 0 },
	{ "VGA320.DRV", DRIVER_VGA320, D_DEFAULT },
	{ "VGA320BW.DRV", DRIVER_VGA320BW, D_DEFAULT },
	{ "EGA320.DRV", DRIVER_EGA320, 0  },
	{ "EGA640.DRV", DRIVER_EGA640, D_DEFAULT },
	{ "MCGA320.DRV", DRIVER_MCGA320, D_DEFAULT },
	{ "TANDY320.DRV", DRIVER_TANDY320, 0  },
	{ "EXPLORER.DRV", DRIVER_EXPLORER, 0  },
	{ "PCJR320.DRV", DRIVER_PCJR320, 0  },
	{ "CGA320M.DRV", DRIVER_CGA320M, 0  },
	{ "CGA320C.DRV", DRIVER_CGA320C, 0  },
	{ "HERCMONO.DRV", DRIVER_HERCMONO, 0  },
	{ "MTPRO.DRV", DRIVER_MTPRO, 0, DRIVER_MT32_NOTE },
	{ "MTBLAST.DRV", DRIVER_MTBLAST, 0, DRIVER_MT32_NOTE },
	{ "MT32.DRV", DRIVER_MT32, D_DEFAULT, DRIVER_MT32_NOTE },
	{ "GENMIDI.DRV", DRIVER_GENMIDI, D_DEFAULT, DRIVER_GENMIDI_NOTE },
	{ "GENMIDMV.DRV", DRIVER_GENMIDMV, 0, DRIVER_GENMIDI_NOTE },
	{ "PROAUDIO.DRV", DRIVER_PROAUDIO, 0  },
	{ "FB01.DRV", DRIVER_FB01, 0  },
	{ "SNDBLAST.DRV", DRIVER_SNDBLAST, 0  },
	{ "ADL.DRV", DRIVER_ADL, D_DEFAULT },
	{ "OPL2LPT.DRV", DRIVER_OPL2LPT, D_DEFAULT },
	{ "MICROSOF.DRV", DRIVER_MICROSOF, 0  },
	{ "SBPRO.DRV", DRIVER_SBPRO, D_DEFAULT },
	{ "CMS.DRV", DRIVER_CMS, 0  },
	{ "TANDY3VD.DRV", DRIVER_TANDY3VD, 0  },
	{ "TANDY3V.DRV", DRIVER_TANDY3V, 0  },
	{ "IBMPS1.DRV", DRIVER_IBMPS1, 0  },
	{ "IMF.DRV", DRIVER_IMF, 0  },
	{ "MT540.DRV", DRIVER_MT540, 0  },
	{ "STD.DRV", DRIVER_STD, D_DEFAULT },
	{ "MIDNONE.DRV", DRIVER_MIDNONE, D_DEFAULT },
	{ "AUDPS1.DRV", DRIVER_AUDPS1, 0  },
	{ "AUDTANDY.DRV", DRIVER_AUDTANDY, 0  },
	{ "AUDPRO.DRV", DRIVER_AUDPRO, 0  },
	{ "AUDPRO16.DRV", DRIVER_AUDPRO16, 0 },
	{ "AUDBLAST.DRV", DRIVER_AUDBLAST, D_DEFAULT },
	{ "AUDTHUND.DRV", DRIVER_AUDTHUND, D_DEFAULT },
	{ "AUDMSSYS.DRV", DRIVER_AUDMSSYS, 0 },
	{ "AUDDISNY.DRV", DRIVER_AUDDISNY, D_DEFAULT },
	{ "AUDNONE.DRV", DRIVER_AUDNONE, 0 },
#ifndef NOJOY
	{ "IBMKBD.DRV", DRIVER_IBMKBD, D_DEFAULT },
	{ "TANDYKBD.DRV", DRIVER_TANDYKBD, D_DEFAULT, DRIVER_TANDYKBD_NOTE },
	{ "JOYSTICK.DRV", DRIVER_JOYSTICK, 0, DRIVER_JOYSTICK_NOTE },
	{ "SUPER.DRV", DRIVER_SUPER, 0  },
	{ "NO", DRIVER_NOJOY, D_DEFAULT },
	{ "STDMOUSE.DRV", DRIVER_STDMOUSE, D_DEFAULT },
	{ "NO", DRIVER_NOMOUSE, 0  },
	{ "ARM.DRV", DRIVER_ARM, 1, DRIVER_ARM_NOTE },
	{ "NO", DRIVER_NOMEMORY, 0  },
#endif
};
char driverAvailable[NUMDRIVERS];
char driverSupported[NUMDRIVERS];

char* driverWarnings[] = { 0, 0, 0, 0, 0, 0, 0 };

//Keep these in the same order as the array above.
typedef enum driverNames
{
	dummy,

	vga320, vga320bw, ega320, ega640, mcga320, tandy320,
	explorer, pcjr320, cga320m, cga320c, hercmono,

	mtpro, mtblast, mt32, genmidi, genmidmv, proaudio,
	fb01, sndblast, adl, opl2lpt, microsof, sbpro, cms,
	tandy3vd, tandy3v, ibmps1, imf, mt540, std, midnone,

	audps1, audtandy, audpro, audpro16, audblast,
	audthund, audmssys, auddisny, audnone,

#ifndef NOJOY
	ibmkbd, tandykbd,

	joystick, super, nojoy,

	stdmouse, nomouse,

	arm, nomemory,
#endif
};

void CheckDrivers();

/*********************************************************
 * SETTINGS
 *********************************************************/

#define MAXSETTINGS 16
typedef struct setting
{
	char key[64];
	char value[128];
} setting;
setting settings[MAXSETTINGS];
setting defaults[MAXSETTINGS];

void SetSetting(setting* map, const char* key, char* value);
char* GetSetting(setting* map, const char* key, char* defVal);
void ReadConfigFile();
void WriteConfigFile();
void DetermineDefaults();
int IsDefaults();
void ResetToDefaults();

#ifdef LANGUAGEPACKS
#define NUMLANGS 106
typedef struct sLanguage
{
	char code[3];
	char* name;
} sLanguage;
const sLanguage languages[NUMLANGS] =
{
	{ "af", "Afrikaans" },
	{ "am", "Amharic" },
	{ "ar", "Arabic" },
	{ "as", "Assamese" },
	{ "az", "Azeri" },
	{ "ba", "Bashkir" },
	{ "be", "Belarusian" },
	{ "bg", "Bulgarian" },
	{ "bn", "Bengali" },
	{ "bo", "Tibetan" },
	{ "br", "Breton" },
	{ "bs", "Bosnian" },
	{ "ca", "Catalan" },
	{ "co", "Corsican" },
	{ "cs", "Czech" },
	{ "cy", "Welsh" },
	{ "da", "Danish" },
	{ "de", "German" },
	{ "dv", "Divehi" },
	{ "el", "Greek" },
	{ "en", "English" },
	{ "es", "Spanish" },
	{ "et", "Estonian" },
	{ "eu", "Basque" },
	{ "fa", "Persian" },
	{ "fi", "Finnish" },
	{ "fo", "Faroese" },
	{ "fr", "French" },
	{ "fy", "Frisian" },
	{ "ga", "Irish" },
	{ "gd", "Scottish Gaelic" },
	{ "gl", "Galician" },
	{ "gu", "Gujarati" },
	{ "ha", "Hausa" },
	{ "he", "Hebrew" },
	{ "hi", "Hindi" },
	{ "hr", "Croatian" },
	{ "hu", "Hungarian" },
	{ "hy", "Armenian" },
	{ "id", "Indonesian" },
	{ "ig", "Igbo" },
	{ "ii", "Yi" },
	{ "is", "Icelandic" },
	{ "it", "Italian" },
	{ "iu", "Inuktitut" },
	{ "ja", "Japanese" },
	{ "ka", "Georgian" },
	{ "kk", "Kazakh" },
	{ "kl", "Greenlandic" },
	{ "km", "Khmer" },
	{ "kn", "Kannada" },
	{ "ko", "Korean" },
	{ "ky", "Kyrgyz" },
	{ "lb", "Luxembourgish" },
	{ "lo", "Lao" },
	{ "lt", "Lithuanian" },
	{ "lv", "Latvian" },
	{ "mi", "Maori" },
	{ "mk", "Macedonian (FYROM)" },
	{ "ml", "Malayalam" },
	{ "mn", "Mongolian" },
	{ "mr", "Marathi" },
	{ "ms", "Malay" },
	{ "mt", "Maltese" },
	{ "nb", "Norwegian (Bokm\xE5l)" },
	{ "ne", "Nepali" },
	{ "nl", "Dutch" },
	{ "nn", "Norwegian (Nynorsk)" },
	{ "no", "Norwegian" },
	{ "oc", "Occitan" },
	{ "or", "Oriya" },
	{ "pa", "Punjabi" },
	{ "pl", "Polish" },
	{ "ps", "Pashto" },
	{ "pt", "Portuguese" },
	{ "rm", "Romansh" },
	{ "ro", "Romanian" },
	{ "ru", "Russian" },
	{ "rw", "Kinyarwanda" },
	{ "sa", "Sanskrit" },
	{ "se", "Sami (Northern)" },
	{ "si", "Sinhala" },
	{ "sk", "Slovak" },
	{ "sl", "Slovenian" },
	{ "sq", "Albanian" },
	{ "sr", "Serbian" },
	{ "sv", "Swedish" },
	{ "sw", "Kiswahili" },
	{ "ta", "Tamil" },
	{ "te", "Telugu" },
	{ "tg", "Tajik" },
	{ "th", "Thai" },
	{ "tk", "Turkmen" },
	{ "tn", "Setswana" },
	{ "tr", "Turkish" },
	{ "tt", "Tatar" },
	{ "ug", "Uyghur" },
	{ "uk", "Ukrainian" },
	{ "ur", "Urdu" },
	{ "uz", "Uzbek" },
	{ "vi", "Vietnamese" },
	{ "wo", "Wolof" },
	{ "xh", "isiXhosa" },
	{ "yo", "Yoruba" },
	{ "zh", "Chinese" },
	{ "zu", "isiZulu" },
};
#endif

/*********************************************************
 * MAIN
 *********************************************************/

void strtoupper(char* str);
void HideCursor();


/*********************************************************
 * VIEWER Implementation
 *********************************************************/

#define MAXVIEWERLINES 1024
#define MAXVIEWERLINELENGTH 70

int haveReadme;
char readmeFile[13];

void ViewFile(const char* filename)
{
	const char* blank = "                                                                           ";
	int i, scroll = 0, lineCt = 0, redraw = 1;
	FILE* fd;
	char** lines;

	fd = fopen(filename, "r");
	if (fd == 0)
		return;

	lines = (char**)calloc(sizeof(char**), MAXVIEWERLINES);
	i = 0;
	lines[i] = (char*)malloc(MAXVIEWERLINELENGTH);
	while (fgets(lines[i], MAXVIEWERLINELENGTH, fd))
	{
		i++;
		lines[i] = (char*)malloc(MAXVIEWERLINELENGTH);
	}
	lineCt = i;
	fclose(fd);

	ClearScreen();
	Window(1,1,77,23, TEXT_README_TITLE, README_COLOR);
	for (i = 2; i < 23; i++)
		SetAttr(2, i, 75, README_TEXT_COLOR);

	while(1)
	{
		if (redraw)
		{
			for (i = 0; i < 21; i++)
			{
				Text(2, 2 + i, blank);
				if (i + scroll < lineCt)
					Text(2, 2 + i, lines[i + scroll]);
			}
			redraw = 0;
		}

		i = getch();
		if (i == 80) //down
		{
			scroll++;
			if (scroll + 21 > lineCt)
				scroll--;
			redraw = 1;
		}
		else if (i == 72) //up
		{
			if (scroll > 0)
				scroll--;
			redraw = 1;
		}
		else if (i == 71) //home
		{
			scroll = 0;
			redraw = 1;
		}
		else if (i == 79) //end
		{
			scroll = lineCt - 21;
			redraw = 1;
		}
		else if (i == 81) //pgdown
		{
			scroll += 21;
			if (scroll + 21 > lineCt)
				scroll = lineCt - 21;
			redraw = 1;
		}
		else if (i == 73) //pgup
		{
			if (scroll < 21)
				scroll = 21;
			scroll -= 21;
			redraw = 1;
		}
		else if (i == 27 || i == 13) //esc or enter
		{
			break;
		}
	}

	for (i = 0; i < MAXVIEWERLINES; i++)
	{
		if(lines[i])
			free(lines[i]);
	}
	free(lines);
	ClearScreen();
}


/*********************************************************
 * INTERFACE Implementation
 *********************************************************/

void ClearScreen()
{
	int i;
	for (i = 0; i < 80 * 25 * 2; i += 2)
	{
		vidya[i] = BACK_CHAR;
		vidya[i + 1] = BACK_COLOR;
	}

	Window(2, 1, 31, 4, 0, CORNER_COLOR);
	Text(5, 2, TEXT_TOPWINDOW);

	Window(46, 21, 32, 3, 0, CORNER_COLOR);
	if (VGALevel >= 1)
		Text(48, 22, TEXT_BOTTOMWINDOW);
	else
	{
		Text(50, 22, TEXT_BOTTOMWINDOW);
		Text(48, 22, "(C)");
	}
}

void Window(int left, int top, int width, int height, const char* title, int colors)
{
	int i, j, c = colors;
	int l = LEFT_LINE, t = TOP_LINE, r = RIGHT_LINE, b = BOT_LINE;
	int tl = TOP_LEFT, tr = TOP_RIGHT, bl = BOT_LEFT, br = BOT_RIGHT;

	if (VGALevel >= 1)
	{
		//Draw shadow
		for (i = top + 1; i < top + height + 1; i++)
		{
			vidya[(((i * 80) + (left + width + 0)) * 2) + 1] &= 0x77;
			vidya[(((i * 80) + (left + width + 1)) * 2) + 1] &= 0x77;
		}
		for (j = left + 2; j < left + width; j++)
			vidya[((((top + height) * 80) + j) * 2) + 1] &= 0x77;
	}
	else
	{
		c = colors & 0x7F;
		l = r = 0xB3; t = b = 0xCD;
		tl = 0xD5; tr = 0xB8; bl = 0xD4; br = 0xBE;

		//Draw shadow
		for (i = top + 1; i < top + height + 1; i++)
		{
			vidya[(((i * 80) + (left + width + 0)) * 2) + 1] = SHADOW_COLOR;
			vidya[(((i * 80) + (left + width + 1)) * 2) + 1] = SHADOW_COLOR;
		}
		for (j = left + 2; j < left + width; j++)
			vidya[((((top + height) * 80) + j) * 2) + 1] = SHADOW_COLOR;
	}

	//Clear out window space
	for (i = top; i < top + height; i++)
		for (j = left; j < left + width; j++)
		{
			vidya[(((i * 80) + j) * 2) + 0] = ' ';
			vidya[(((i * 80) + j) * 2) + 1] = c;
		}

	//Draw horizontal border lines
	for (j = left + 1; j < left + width - 1; j++)
	{
		vidya[(((top * 80) + j) * 2)] = t;
		vidya[((((top + height - 1) * 80) + j) * 2)] = b;
	}
	//Draw vertical border lines
	for (i = top + 1; i < top + height - 1; i++)
	{
		vidya[((i * 80) + left) * 2] = l;
		vidya[((i * 80) + left + width - 1) * 2] = r;
	}
	//Draw corners
	vidya[((top * 80) + left) * 2] = tl;
	vidya[((top * 80) + left + width - 1) * 2] = tr;
	vidya[(((top + height - 1) * 80) + left) * 2] = bl;
	vidya[(((top + height - 1) * 80) + left + width - 1) * 2] = br;

	if (title)
	{
#ifdef NORTON
		if (VGALevel >= 1)
		{
			i = ((colors & 0xF) << 4) | ((colors & 0xF0) >> 4);
			for (j = left; j < left + width; j++)
			{
				vidya[(((top * 80) + j) * 2) + 0] = ' ';
				vidya[(((top * 80) + j) * 2) + 1] = i;
			}
			i = left + ((width / 2) - (strlen(title) / 2));
			Text(i, top, title);
		}
		else
		{
#endif
		i = left + ((width / 2) - (strlen(title) / 2));
		Text(i, top, title);
		i -= left + 2;
		vidya[((top * 80) + left + i + 0) * 2] = TITLE_LEFT;
		vidya[((top * 80) + left + i + 1) * 2] = ' ';
		i += strlen(title) + 2;
		vidya[((top * 80) + left + i + 1) * 2] = TITLE_RIGHT;
		vidya[((top * 80) + left + i + 0) * 2] = ' ';
#ifdef NORTON
		}
#endif
	}
}

void SetAttr(int left, int top, int width, int color)
{
	int i = ((top * 80) + left) * 2;
	if (VGALevel < 1) color &= 0xFF7F;
	i++;
	while (width--)
	{
		vidya[i] = color;
		i+=2;
	}
}

void Text(int left, int top, const char* text)
{
	int i = ((top * 80) + left) * 2;
	while (*text)
	{
		if (*text == '\n')
		{
			text++;
			top++;
			i = ((top * 80) + left) * 2;
			continue;
		}
		else if (*text == '\t')
		{
			text++;
			i += 6;
		}
		vidya[i] = *text;
		i += 2;
		text++;
	}
}

void PadText(int left, int top, int width, const char* text)
{
	int i = ((top * 80) + left) * 2, len = 0;
	while (*text)
	{
		if (*text == '\n')
		{
			text++;
			top++;
			i = ((top * 80) + left) * 2;
			continue;
		}
		else if (*text == '\t')
		{
			text++;
			i += 6;
		}
		vidya[i] = *text;
		i += 2;
		text++;
		len++;
	}
	while (len < width)
	{
		vidya[i] = ' ';
		i += 2;
		len++;
	}
}


int Message(const char* message, const char* title, int colors)
{
	int i, y, lines = 0, width = 10, widthSoFar = 0, x;
	int enterOrEsc = colors & MESSAGE_ENTERORESC;
	int yesOrNo = colors & MESSAGE_YESORNO;
	int buttonLefts[2];
	int buttonWidths[2];
	char* b800 = (char*)malloc(80 * 25 * 2);
	char* wrapped = Wrap(message, 62);
	colors = colors & 0xFF;
	//memcpy((void*)b800, (void*)vidya, 80 * 25 * 2);
	for (i = 0; i < 80 * 25 * 2; i++) b800[i] = vidya[i];
	if (title)
	{
		width = strlen(title);
#ifdef NORTON
		lines++;
#endif
	}
	for (i = strlen(wrapped); i > 0; --i)
	{
		if (wrapped[i] == '\n')
		{
			widthSoFar = 0;
			lines++;
		} else
		{
			widthSoFar++;
			if (widthSoFar > width)
				width = widthSoFar;
		}
	}
	lines += 3;
	width += 4;

	if (enterOrEsc || yesOrNo)
	{
		width = width < MIN_BUTTON_WIDTH ? MIN_BUTTON_WIDTH : width;
		lines += 2;
	}

	y = 12 - (lines / 2);
	x = 40 - (width / 2);

	Window(x, y, width, lines, title, colors);
#ifdef NORTON
	Text(x + 2, y + (title ? 2 : 1), wrapped);
#else
	Text(x + 2, y + 1, wrapped);
#endif

	//free(wrapped);

	if (enterOrEsc)
	{
		buttonLefts[0] = x + 2;
		buttonWidths[0] = TEXT_BUTTON_CONTINUE_WIDTH;
		buttonLefts[1] = x + 2 + TEXT_BUTTON_CONTINUE_WIDTH + 2;
		buttonWidths[1] = TEXT_BUTTON_CANCEL_WIDTH;
		Text(buttonLefts[0], y + lines - 2, TEXT_BUTTON_CONTINUE);
		Text(buttonLefts[1], y + lines - 2, TEXT_BUTTON_CANCEL);
	}
	else if (yesOrNo)
	{
		buttonLefts[0] = x + 2;
		buttonWidths[0] = TEXT_BUTTON_YES_WIDTH;
		buttonLefts[1] = x + 2 + TEXT_BUTTON_YES_WIDTH + 2;
		buttonWidths[1] = TEXT_BUTTON_NO_WIDTH;
		Text(buttonLefts[0], y + lines - 2, TEXT_BUTTON_YES);
		Text(buttonLefts[1], y + lines - 2, TEXT_BUTTON_NO);
	}

	if (!(enterOrEsc || yesOrNo))
		i = getch();
	else
	{
		int button = 0, chosen = 0;
		while (!chosen)
		{
			if (VGALevel >= 1)
			{
				SetAttr(buttonLefts[0], y + lines - 2, buttonWidths[0], button == 0 ? BUTTON_FOCUS : BUTTON_NORMAL);
				SetAttr(buttonLefts[1], y + lines - 2, buttonWidths[1], button == 1 ? BUTTON_FOCUS : BUTTON_NORMAL);
			} else
			{
				SetAttr(buttonLefts[0], y + lines - 2, buttonWidths[0], button == 0 ? BUTTON_FOCUS_EGA : BUTTON_NORMAL_EGA);
				SetAttr(buttonLefts[1], y + lines - 2, buttonWidths[1], button == 1 ? BUTTON_FOCUS_EGA : BUTTON_NORMAL_EGA);
			}
			i = getch();
			switch (i)
			{
				case 9:
				case 75:
				case 77:
					button = !button;
					break;
				case 13:
					if (button == 0) i = enterOrEsc ? 13 : 'y';
					if (button == 1) i = enterOrEsc ? 27 : 'n';
					chosen = 1;
					break;
				case 27:
					chosen = 1;
					break;
				case 'y':
				case 'n':
					if (yesOrNo) chosen = 1;
					break;
			}
			//if (enterOrEsc && (i == 27 || i == 13))
			//	break;
		}
	}

	//while(kbhit()); /*...*/ ;
	//ClearScreen();
	//memcpy((void*)vidya, (void*)b800, 80 * 25 * 2);
	for (y = 0; y < 80 * 25 * 2; y++) vidya[y] = b800[y];
	free(b800);
	return i;
}

int DoMenu(menuList* list)
{
	int i, x, winY, listY, h, lines, width = 30, widthSoFar = 0;
	int rewriteNow = 1, scrollOffset = 0, thumb = -1;

	h = 4 + (list->count > MAXLISTSHOWN ? MAXLISTSHOWN : list->count);
	x = 15;

	if (list->title)
		widthSoFar = strlen(list->title);
	if (widthSoFar > width)
		width = widthSoFar;

	for (i = 0; i < MAXLISTSHOWN && i < list->count; i++)
	{
		widthSoFar = strlen(list->items[i]) + (list->wantChecks ? 6 : 4);
		if (widthSoFar > width)
			width = widthSoFar;
	}

	if (list->count > MAXLISTSHOWN)
		width += 8;
	while (list->active - scrollOffset >= MAXLISTSHOWN)
		scrollOffset++;

	lines = 0;
	if (list->headText)
	{
		Wrap(list->headText, width);
		for (i = strlen(wrapBuffer); i > 0; --i)
		{
			if (wrapBuffer[i] == '\n')
			{
				lines++;
				h++;
			}
		}
		lines++;
		h++;
		if (list->title)
		{
			lines++;
			h++;
		}
	}
//#ifndef NORTON
//	lines--;
	h--;
//#endif

	width += 6;
	x = 40 - (width / 2);

	winY = 11 - ((lines + (list->count > MAXLISTSHOWN ? MAXLISTSHOWN : list->count)) / 2);
	listY = winY + lines + 2;

	Window(x, winY, width, h, list->title, MENU_COLOR);
	if (list->headText)
	#ifdef NORTON
		Text(x + 2, winY + (list->title ? 2 : 1), wrapBuffer);
	#else
		Text(x + 2, winY + 1, wrapBuffer);
	#endif

	if (list->count > MAXLISTSHOWN)
	{
		if (VGALevel >= 1)
		{
			vidya[(((listY * 80) + x + width - 4) * 2)+0] = 0xE0;
			vidya[(((listY * 80) + x + width - 4) * 2)+1] = 0xF0;
			vidya[(((listY * 80) + x + width - 4) * 2)+2] = 0xE1;
			vidya[(((listY * 80) + x + width - 4) * 2)+3] = 0xF0;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+0] = 0xE2;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+1] = 0xF0;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+2] = 0xE3;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+3] = 0xF0;
			for (i = listY + 1; i < listY + MAXLISTSHOWN - 1; i++)
			{
				vidya[(((i * 80) + x + width - 4) * 2)+0] = 0xB9;
				vidya[(((i * 80) + x + width - 4) * 2)+1] = 0x70;
				vidya[(((i * 80) + x + width - 4) * 2)+2] = 0xD9;
				vidya[(((i * 80) + x + width - 4) * 2)+3] = 0x70;
			}
		}
		else
		{
			vidya[(((listY * 80) + x + width - 4) * 2)+2] = 0x1E;
			vidya[(((listY * 80) + x + width - 4) * 2)+3] = 0x70;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+2] = 0x1F;
			vidya[((((listY + MAXLISTSHOWN - 1) * 80) + x + width - 4) * 2)+3] = 0x70;
			for (i = listY + 1; i < listY + MAXLISTSHOWN - 1; i++)
			{
				vidya[(((i * 80) + x + width - 4) * 2)+2] = 0xB1;
				vidya[(((i * 80) + x + width - 4) * 2)+3] = 0x78;
			}
		}
	}

	while(1)
	{
		if (rewriteNow)
		{
			rewriteNow = 0;

			if (list->wantChecks)
			{
				for (i = 0; i < MAXLISTSHOWN && i < list->count; i++)
				{
					PadText(x + 7, listY + i, width - 12, list->items[i + scrollOffset]);
					if (list->check[i + scrollOffset])
						Text(x + 5, listY + i, "\xFB");
					else
						Text(x + 5, listY + i, " ");
				}
			} else
			{
				for (i = 0; i < MAXLISTSHOWN && i < list->count; i++)
					PadText(x + 5, listY + i, width - 12, list->items[i + scrollOffset]);
			}

		}

		if (list->count > MAXLISTSHOWN)
		{
			if (thumb != -1)
				SetAttr(x + width - (VGALevel >= 1 ? 4 : 3), listY + 1 + thumb, (VGALevel >= 1 ? 2 : 1), (VGALevel >= 1 ? 0x70 : 0x78));
			thumb = (int)(((float)list->active / (float)(list->count - 1)) * (MAXLISTSHOWN - 3));
			SetAttr(x + width - (VGALevel >= 1 ? 4 : 3), listY + 1 + thumb, (VGALevel >= 1 ? 2 : 1), (VGALevel >= 1 ? 0xF0 : 0x7F));
		}

		for (i = 0; i < MAXLISTSHOWN && i < list->count; i++)
			SetAttr(x + 4, listY + i, width - 8, i + scrollOffset == list->active ? SELECT_COLOR : MENU_COLOR);
		i = getch();
		if (i == 80) //down
		{
			if (list->active < list->count - 1)
			{
				list->active++;
				if (list->items[list->active][0] == 0)
					list->active++;
				if (list->active == scrollOffset + MAXLISTSHOWN)
				{
					scrollOffset++;
					rewriteNow = 1;
				}
			}
			//if (list->active >= list->count)
			//	list->active = 0;
		}
		else if (i == 72) //up
		{
			//if (list->active == 0)
			//	list->active = list->count;
			if (list->active > 0)
			{
				list->active--;
				if (list->items[list->active][0] == 0)
					list->active--;
				if (list->active < scrollOffset && scrollOffset > 0)
				{
					scrollOffset--;
					rewriteNow = 1;
				}
			}
		}
		else if (i == 27) //esc
		{
			//ClearScreen();
		 	return -1;
		}
		else if (i == 13) //enter
		{
			//ClearScreen();
			return list->active;
		}
	}
	//return 0;
}

char* Wrap(const char *s, int lineSize)
{
	const char *head = s;
	int pos, lastSpace;
	char *o = wrapBuffer;
	for (pos = 0; pos < 1024; pos++) wrapBuffer[0] = 0;

	pos = lastSpace = 0;
	while(head[pos] != 0)
	{
		int isLf = (head[pos] == '\n');
		if (isLf || pos == lineSize)
		{
			if (isLf || lastSpace == 0) lastSpace = pos; //just cut it
			while (*head != 0 && lastSpace-- > 0) *o++ = *head++;
			*o++ = '\n';
			if (isLf) head++; //jump the line feed
			while (*head != 0 && *head == ' ') head++; //clear the leading space
			lastSpace = pos = 0;
		} else
		{
			if (head[pos] == ' ')
				lastSpace = pos;
			pos++;
		}
	}
    while (*head !=0) *o++ = *head++;
    *o++ = 0;
	return wrapBuffer;
}

#ifdef NORTON
void FuckUpFont()
{
	int i, j, k;

	//simple-ass format, really.
	const unsigned char font[] =
	{
		0xB9, //0 - Left
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
		0xC1, //1 - Top
			0xFF,0xFF,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
		0xC2, //2 - Top-Right
			0xFF,0xFF,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
		0xC8, //3 - Bottom-Right
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0xFF,0xFF,
		0xC9, //4 - Top-Left
			0xFF,0xFF,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
		0xCC, //5 - Bottom-Left
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xFF,0xFF,
		0xCD, //6 - Bottom
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0xFF,0xFF,
		0xD9, //7 - Right
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
		0xB8, //8 - Copyright
			0x00,0x00,0x7C,0x82,
			0x9A,0xA2,0xA2,0xA2,
			0x9A,0x82,0x7C,0x00,
			0x00,0x00,0x00,0x00,
		0xAA, //9 - Trademark
			0x00,0xF1,0x5B,0x55,
			0x51,0x51,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
		0xA9, //10 - Registered
			0x00,0x00,0x7C,0x82,
			0xB2,0xAA,0xB2,0xAA,
			0xAA,0x82,0x7C,0x00,
			0x00,0x00,0x00,0x00,
		0xF5, //11 - Euro
			0x00,0x00,0x00,0x1C,
			0x36,0x60,0xFC,0x60,
			0xF8,0x60,0x36,0x1C,
			0x00,0x00,0x00,0x00,
		0xFB, //12 - Checkmark
			0x00,0x01,0x03,0x02,
			0x06,0x04,0x0C,0x88,
			0xD8,0x50,0x70,0x20,
			0x00,0x00,0x00,0x00,
		0xE0, //13 - Scroll up, wide left
			0xFF,0x80,0x81,0x83,
			0x87,0x8F,0x9F,0xBF,
			0x83,0x83,0x83,0x83,
			0x83,0x80,0x80,0xFF,
		0xE1, //14 - Scroll up, wide right
			0xFF,0x01,0x81,0xC1,
			0xE1,0xF1,0xF9,0xFD,
			0xC1,0xC1,0xC1,0xC1,
			0xC1,0x01,0x01,0xFF,
		0xE2, //15 - Scroll down, wide left
			0xFF,0x80,0x80,0x83,
			0x83,0x83,0x83,0x83,
			0xBF,0x9F,0x8F,0x87,
			0x83,0x81,0x80,0xFF,
		0xE3, //16 - Scroll down, wide right
			0xFF,0x01,0x01,0xC1,
			0xC1,0xC1,0xC1,0xC1,
			0xFD,0xF9,0xF1,0xE1,
			0xC1,0x81,0x01,0xFF,
	};

	const unsigned char font14[] =
	{
		0xB9, //0 - Left
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
		0xC1, //1 - Top
			0xFF,0xFF,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
		0xC2, //2 - Top-Right
			0xFF,0xFF,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
		0xC8, //3 - Bottom-Right
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0xFF,0xFF,0xFF,0xFF,
		0xC9, //4 - Top-Left
			0xFF,0xFF,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
		0xCC, //5 - Bottom-Left
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xC0,0xC0,0xC0,0xC0,
			0xFF,0xFF,0xFF,0xFF,
		0xCD, //6 - Bottom
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0xFF,0xFF,0xFF,0xFF,
		0xD9, //7 - Right
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
			0x03,0x03,0x03,0x03,
		0xB8, //8 - Copyright
			0x00,0x00,0x7C,0x82,
			0x9A,0xA2,0xA2,0xA2,
			0x9A,0x82,0x7C,0x00,
			0x00,0x00,0x00,0x00,
		0xAA, //9 - Trademark
			0x00,0xF1,0x5B,0x55,
			0x51,0x51,0x00,0x00,
			0x00,0x00,0x00,0x00,
			0x00,0x00,0x00,0x00,
		0xA9, //10 - Registered
			0x00,0x00,0x7C,0x82,
			0xB2,0xAA,0xB2,0xAA,
			0xAA,0x82,0x7C,0x00,
			0x00,0x00,0x00,0x00,
		0xF5, //11 - Euro
			0x00,0x00,0x00,0x1C,
			0x36,0x60,0xFC,0x60,
			0xF8,0x60,0x36,0x1C,
			0x00,0x00,0x00,0x00,
		0xFB, //12 - Checkmark
			0x00,0x01,0x03,0x02,
			0x06,0x04,0x0C,0x88,
			0xD8,0x50,0x70,0x20,
			0x00,0x00,0x00,0x00,
		0xE0, //13 - Scroll up, wide left
			0xFF,0x80,0x81,0x83,
			0x87,0x8F,0x9F,0xBF,
			0x83,0x83,0x83,0x83,
			0x80,0xFF,0xFF,0xFF,
		0xE1, //14 - Scroll up, wide right
			0xFF,0x01,0x81,0xC1,
			0xE1,0xF1,0xF9,0xFD,
			0xC1,0xC1,0xC1,0xC1,
			0x01,0xFF,0xFF,0xFF,
		0xE2, //15 - Scroll down, wide left
			0xFF,0x80,0x83,0x83,
			0x83,0x83,0xBF,0x9F,
			0x8F,0x87,0x83,0x81,
			0x80,0xFF,0xFF,0xFF,
		0xE3, //16 - Scroll down, wide right
			0xFF,0x01,0xC1,0xC1,
			0xC1,0xC1,0xFD,0xF9,
			0xF1,0xE1,0xC1,0x81,
			0x01,0xFF,0xFF,0xFF,
	};


	//Switch in the character set so we can change that.
	//The character set for text mode is in plane 2, and unchained.
	outportb(0x3CE, 0x05); //Graphics Mode
	outportb(0x3CF, 0x00); //Write Mode 0
	outportb(0x3CE, 0x06); //Misc Graphics
	outportb(0x3CF, 0x0C); //Memory Map B800-BFFF
	outportb(0x3C4, 0x04); //Sequencer Memory Mode
	outportb(0x3C5, 0x06); //Extended Memory | Odd/Even Write Address Disable
	outportb(0x3C4, 0x02); //Map Mask
	outportb(0x3C5, 0x04); //Plane 2
	outportb(0x3CE, 0x04); //Read Map Select
	outportb(0x3CF, 0x02);


	if (VGALevel == 2)
	{
		for (i = 0; i <= 16; i++)
		{
			k = i * 17;
			for(j = 0; j < 16; j++)
				vidya[font[k] * 32 + j] = font[k + 1 + j];
		}
	}
	else
	{
		for (i = 0; i <= 16; i++)
		{
			k = i * 17;
			for(j = 0; j < 16; j++)
				vidya[font[k] * 32 + j] = font14[k + 1 + j];
		}
	}

	//Switch back to text.
	//In this case the character bytes are in plane 0 and attribs are in plane 1.
	//These are --chained odd/even--, so we get the familiar [attr|char] setup.
	outportb(0x3CE, 0x05); //Graphics Mode
	outportb(0x3CF, 0x10); //Write Mode 0 | Host Odd/Even Read Addressing
	outportb(0x3CE, 0x06); //Misc Graphics
	outportb(0x3CF, 0x0E); //Memory Map B800-BFFF | Chain Odd/Even
	outportb(0x3C4, 0x04); //Sequencer Memory Mode
	outportb(0x3C5, 0x02); //Extended Memory
	outportb(0x3C4, 0x02); //Map Mask
	outportb(0x3C5, 0x03); //Planes 0 and 1
	outportb(0x3CE, 0x04); //Read Map Select
	outportb(0x3CF, 0x00);
}
#endif



/*********************************************************
 * DRIVERS Implementation
 *********************************************************/

//Go through all the listed drivers, see if their respective files exist.
void CheckDrivers()
{
	int i;
	struct ffblk ff;

#ifndef NOJOY
	for(i = 1; i < nojoy; i++)
#else
	for(i = 1; i <= audnone; i++)
#endif
		driverAvailable[i] = !findfirst(drivers[i].file, &ff, 0);

	//not real drivers, in the sense that they have no DRV files.
#ifndef NOJOY
	for (i = nojoy; i <= nomemory; i++)
		driverAvailable[i] = 1;
#endif

	strcpy(readmeFile, "README");
	haveReadme = !findfirst(readmeFile, &ff, 0) ? 2 : 0;
	if (!haveReadme)
	{
		strcpy(readmeFile, "READ.ME");
		haveReadme = !findfirst(readmeFile, &ff, 0) ? 2 : 0;
		if (!haveReadme)
		{
			strcpy(readmeFile, "README.TXT");
			haveReadme = !findfirst(readmeFile, &ff, 0) ? 2 : 0;
		}
	}
}

#ifndef MEINLEBEN
int sbLocation, skipSBDetect;
int CheckSoundBlaster(int port)
{
	int i;
	sbLocation = port << 4;
	outportb(sbLocation + 0x206, 1); //Reset the DSP, or try to at least
	asm {
		mov dx, 0x388
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		in al, dx
		in al, dx
	}
	outportb(sbLocation + 0x206, 0);

	asm mov dx, 0x388
	asm mov cx, 100
resetLoop:
	asm in al, dx
	asm loop resetLoop

	for (i = 0; i < 100; i++)
		if (inportb(sbLocation + 0x20e) & 0x80) //If data is available...
			return (inportb(sbLocation + 0x20a) == 0xAA); //...and it's what we expected.
	return 0;
}

int DetectSoundBlaster()
{
	int i;
	if (CheckSoundBlaster(2)) return 1; //Check default first
	if (CheckSoundBlaster(4)) return 1; //Check Pro default
	for (i = 1; i <= 6; i++)
	{
		if (i == 2 || i == 4) continue;
		if (CheckSoundBlaster(i)) return 1;
	}
	return 0;
}

int DetectSoundBlasterPro()
{
	int oldFMMix, test;
	outportb(sbLocation + 0x204, 0x26);
	oldFMMix = inportb(sbLocation + 0x205);
	outportb(sbLocation + 0x205, 0xBB);
	test = inportb(sbLocation + 0x205);
	if (test == 0xBB)
	{
		outportb(sbLocation + 0x205, oldFMMix);
		return 1;
	}
	return 0;
}

void AdLibSend(char n, char b) {
asm {
	pushf
	cli

	mov	dx, 0x388
	mov	al, [n]
	out	dx, al
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	inc	dx
	mov	al, [b]
	out	dx, al

	popf

	dec	dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
}}

int DetectAdLib()
{
	char status1, status2;
	AdLibSend(4, 0x60); //Reset T1/T2
	AdLibSend(4, 0x80); //Reset IRQ
	status1 = inportb(0x388);
	AdLibSend(2, 0xFF); //Set timer 1
	AdLibSend(4, 0x21); //Start timer 1

	asm mov dx, 0x388
	asm mov cx, 100
resetLoop:
	asm in al, dx
	asm loop resetLoop

	status2 = inportb(0x388);
	AdLibSend(4, 0x60);
	AdLibSend(4, 0x80);
	if (((status1 & 0xE0) == 0) && ((status2 & 0xE0) == 0xC0))
		return 1;
	return 0;
}

void Opl2LptSend(char n, char b) {
asm {
	pushf
	cli

	mov	dx, 0x378
	mov	al, [n]
	out	dx, al
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	inc	dx
	mov	al, [b]
	out	dx, al

	popf

	dec	dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx

	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
	in	al, dx
}}

int DetectOpl2Lpt()
{
	char status1, status2;
	AdLibSend(4, 0x60); //Reset T1/T2
	AdLibSend(4, 0x80); //Reset IRQ
	status1 = inportb(0x378);
	AdLibSend(2, 0xFF); //Set timer 1
	AdLibSend(4, 0x21); //Start timer 1

	asm mov dx, 0x378
	asm mov cx, 100
resetLoop:
	asm in al, dx
	asm loop resetLoop

	status2 = inportb(0x378);
	AdLibSend(4, 0x60);
	AdLibSend(4, 0x80);
	if (((status1 & 0xE0) == 0) && ((status2 & 0xE0) == 0xC0))
		return 1;
	return 0;
}
#endif

void CheckSupport()
{
	char vga, ega, vgaFunCheck, timeout;
	int mouse, winHack;
	FILE* emm;

	//Always support these.
	driverSupported[std] = 1;
	driverSupported[midnone] = 1;
	driverSupported[audnone] = 1;
#ifndef NOJOY
	driverSupported[nojoy] = 1;
#endif

	asm {
		mov ah, 0x12
		mov bl, 0x10
		int 0x10
		mov ega, bl
	}
	ega = (ega != 0x10);
	asm {
		mov ax, 0x1A00
		int 0x10
		mov vgaFunCheck, al
		mov vga, bl
	}
	if (vgaFunCheck != 0x1A) vga = 0;
	driverSupported[vga320] = (vga == 8);
	driverSupported[vga320bw] = (vga == 7 || vga == 8);
	driverSupported[ega640] = (ega || (vga == 8));
	driverSupported[hercmono] = (ega == 0 && vga == 0);
	VGALevel = 0;
	if (ega) VGALevel = 1;
	if (driverSupported[vga320bw]) VGALevel = 2;

	if (VGALevel >= 1)
	{
		//Try to detect Windows 95
		asm {
			xor ax, ax
			mov es, ax
			mov di, ax
			mov ax, 0x1602
			int 0x2F
			mov winHack, es
		}
		//printf("Winhack is %x", winHack); getch();
		if (winHack)
			VGALevel = 0;
	}

/*
#ifdef NORTON
	if (VGALevel < 1)
	{
		printf("Sorry, this thing's too cool for your system.\nGet a copy of Sierra's installer -- it'll do the same things.\n");
		exit(0);
	}
#endif
*/

	if (driverAvailable[mt32] || driverAvailable[genmidi])
	{
		timeout = 1000; while (timeout-- && (inp(0x331) & 0x40)) ;
		outportb(0x331, 0x3F);
		timeout = 1000; while (timeout-- && (inp(0x331) & 0x80)) ;
		driverSupported[mt32] = driverSupported[genmidi] = (inp(0x330) == 0xFE);
	}


#ifndef MEINLEBEN
	if (!skipSBDetect)
	{
		if (driverAvailable[sndblast])
			driverSupported[audblast] = DetectSoundBlaster();
		if (driverAvailable[sbpro])
			driverSupported[sbpro] = DetectSoundBlasterPro();
		if (driverAvailable[adl])
			driverSupported[adl] = driverSupported[audblast] & DetectAdLib();
		if (driverAvailable[opl2lpt])
			driverSupported[opl2lpt] = DetectOpl2Lpt();
	} else
	{
#endif
	//Original INSTALL.EXE tries DSP Reset commands to detect SB. Whatever, nerd.
	char* blaster = getenv("BLASTER");
	if (blaster)
	{
		char blasterType = *(strchr(blaster, 'T') + 1) - '0';
		if (blasterType >= 1) //T4 = SBPro, so SB2, SB1.5, or SB1.0
		{
			driverSupported[sndblast] = driverAvailable[sndblast];
			driverSupported[adl] = driverAvailable[adl];
			driverSupported[audblast] = driverAvailable[audblast];
		}
		if (blasterType >= 5) //T6 = SB16, so SBPro and earlier
		{
			driverSupported[sbpro] = 1;
		}
	}
#ifndef MEINLEBEN
	}
#endif
	driverSupported[audthund] = driverSupported[audblast];

#ifndef NOJOY
	//TODO: Detect joysticks. If found, disable nojoy.

	asm {
		xor ax, ax
		int 0x33
		mov mouse, ax
	}
	driverSupported[stdmouse] = abs(mouse);

	emm = fopen("EMMXXXX0", "r");
	if (emm)
	{
    	struct stat fs;
		fstat(fileno(emm), &fs);
		fclose(emm);
		driverSupported[arm] = (fs.st_mode & S_IFCHR ? 1 : 0);
	}
#endif
}

//Produce a driver selection function.
// > wid: index into driverWarnings array.
// > fname: the name of the function to create.
// > key: the RESOURCE.CFG setting this would change.
// > firstDrv: the first driver (from the drivers enum) to consider listing.
// > lastDrv: the last driver (from the drivers enum) to consider listing.
// > header: the text to show above the list.
#define MAKEDRIVERMENU(wid, fname, key, firstDrv, lastDrv, header) \
void fname (void) \
{ \
	int i; \
	char* current = GetSetting(settings, key, 0); \
	menuList* list = (menuList*)calloc(sizeof(menuList), 1); \
	list->headText = header; \
	list->active = 0; \
	list->wantChecks = 1; \
	for (i = firstDrv; i <= lastDrv; i++) \
	{ \
		if (driverAvailable[i]) \
		{ \
			list->items[list->count] = (char*)drivers[i].name; \
			list->keys[list->count] = i; \
			list->check[list->count] = driverSupported[i]; \
			if (stricmp(drivers[i].file, current) == 0) \
				list->active = list->count; \
			list->count++; \
		} \
	} \
	ClearScreen(); \
	i = DoMenu(list); \
	if (i != -1) \
	{ \
		driverWarnings[wid] = 0; \
		if (drivers[list->keys[i]].warning != 0) \
		{ \
			Message(drivers[list->keys[i]].warning, TEXT_WARNING_TITLE, MESSAGE_COLOR); \
		} \
		SetSetting(settings, key, (char*)drivers[list->keys[i]].file); \
	} \
	free(list); \
}

MAKEDRIVERMENU(0, SelectVideo, "videoDrv", vga320, hercmono, TEXT_DRIVER_VIDEO)
MAKEDRIVERMENU(1, SelectMusic, "soundDrv", mtpro, midnone, TEXT_DRIVER_MUSIC)
MAKEDRIVERMENU(2, SelectAudio, "audioDrv", audps1, audnone, TEXT_DRIVER_AUDIO)
#ifndef NOJOY
MAKEDRIVERMENU(3, SelectKeyboard, "kbdDrv", ibmkbd, tandykbd, TEXT_DRIVER_KEYBOARD)
MAKEDRIVERMENU(4, SelectJoystick, "joyDrv", joystick, nojoy, TEXT_DRIVER_JOYSTICK)
MAKEDRIVERMENU(5, SelectMouse, "mouseDrv", stdmouse, nomouse, TEXT_DRIVER_MOUSE)
MAKEDRIVERMENU(6, SelectMemory, "memoryDrv", arm, nomemory, TEXT_DRIVER_MEMORY)
#endif

#undef MAKEDRIVERMENU

void DoWarnings()
{
	int i;
	for (i = 0; i < 7; i++)
	{
		if (driverWarnings[i])
			Message(driverWarnings[i], TEXT_WARNING_TITLE, MESSAGE_COLOR);
	}
}

#ifdef LANGUAGEPACKS
void SelectLanguage(void)
{
	int i;
	char langAvailable[NUMLANGS] = { 0 };
	DIR *dir;
	struct dirent *ent;
	char *current, *setting, *found;
	menuList* list;

	for (i = 0; i < NUMLANGS; i++)
		if (!strcmp(languages[i].code, "en"))
		{
			langAvailable[i] = 1;
			break;
		}

	dir = opendir("lang");
	if (dir == 0) return; //no langs directory at all
	while ((ent = readdir(dir)) != 0)
	{
	if (ent->d_name[0] == '.')
			continue;
		for (i = 0; i < NUMLANGS; i++)
			if (!stricmp(languages[i].code, ent->d_name))
			{
				langAvailable[i] = 1;
				break;
			}
	}
	closedir(dir);

	current = "en";
	setting = GetSetting(settings, "patchDir", ".");
	found = strstr(setting, "lang\\");
	if (found != 0)
	{
		current = found + 5; //skip over to lang code
		current[2] = 0; //ensure two-letter code;
	}

	list = (menuList*)calloc(sizeof(menuList), 1);
	list->headText = TEXT_LANGUAGE;
	list->active = 0;
	list->wantChecks = 0;
	for (i = 0; i < NUMLANGS; i++)
	{
		if (langAvailable[i])
		{
			list->items[list->count] = (char*)languages[i].name;
			list->keys[list->count] = i;
			if (stricmp(languages[i].code, current) == 0)
				list->active = list->count;
			list->count++;
		}
	}
	ClearScreen();
	i = DoMenu(list);
	if (i != -1)
	{
		i = list->keys[i];
		if (!strcmp(languages[i].code, "en"))
		{
			SetSetting(settings, "patchDir", 0);
		}
		else
		{
			setting = ".;.\\lang\\XX";
			setting[9] = languages[i].code[0];
			setting[10] = languages[i].code[1];
			SetSetting(settings, "patchDir", setting);
		}
	}
	free(list);
}
#endif

/*********************************************************
 * SETTINGS Implementation
 *********************************************************/

char resCfg[32] = RESCFG;

//Stores a value in our settings dictionary.
//If the key does not exist, it is added.
// > key: the setting's name.
// > value: the new value to store.
void SetSetting(setting* map, const char* key, char* value)
{
	int i;
	for (i = 0; i < MAXSETTINGS; i++)
	{
		if (map[i].key[0] == '\0')
		{
			strcpy(map[i].key, key);
			strcpy(map[i].value, value);
			return;
		}
		if (stricmp(map[i].key, key) == 0)
		{
			strcpy(map[i].value, value);
			return;
		}
	}
}

//Retrieves a value from our settings directory.
//If the key does not exist, returns a default.
// > key: the setting's name.
// > defVal: what to return if the key doesn't exist.
char* GetSetting(setting* map, const char* key, char* defVal)
{
	int i;
	for (i = 0; i < MAXSETTINGS; i++)
	{
		if (map[i].key[0] == '\0')
			return defVal;
		if (stricmp(map[i].key, key) == 0)
			return map[i].value;
	}
	return 0;
}

//stolen from SSCI
char* gettok(char* str, char* buf, const char* seps, int n)
{
	//Start by scanning off any leading separators.
	while (*str && strchr(seps, *str)) //strpbrk(str, seps)) //strchr(seps, *str))
		++str;
	if (*str == '\0')
	{
		*buf = '\0';
		return 0;
	}
	//Copy a token to storage.
	while (--n && *str && strchr(seps, *str) == 0) //strpbrk(str, seps) == 0) //strchr(seps, *str) == 0)
		*buf++ = *str++;
	*buf = '\0';
	return str;
}

//Opens and parses RESOURCE.CFG. Tries to make a default copy
//if RESOURCE.CFG does not exist.
void ReadConfigFile()
{
   	const char* sepStr = " \t=";
	FILE* fd;
	char line[256];
	char* str;
	char key[64];
	char val[128];
	//int numSettings = 0;
	int i;

	ResetToDefaults();
	fd = fopen(resCfg, "r");
	if (fd == 0)
	{
		//Message(TEXT_NORESCFG, MESSAGE_COLOR);
		SetSetting(settings, "minHunk", "220k");
		//WriteConfigFile();
		return;
	}

	while (fgets(line, sizeof(line), fd))
	{
		//strlwr(line);
		line[strlen(line)-1] = 0; //cut off \n
		str = gettok(line, key, sepStr, 64);
		gettok(str, val, sepStr, 128);
		SetSetting(settings, key, val);
		//numSettings++;
	}
	fclose(fd);
}

//Stores the settings dictionary to a RESOURCE.CFG file.
void WriteConfigFile()
{
	int i;
	FILE* fd;
	fd = fopen(resCfg, "w");
	if (fd == 0)
	{
		Message(TEXT_CANTWRITE, 0, MESSAGE_COLOR);
		Exit(1);
		return;
	}
	for (i = 0; i < MAXSETTINGS; i++)
	{
		if (settings[i].key[0] == '\0')
			break;
		if (settings[i].value[0] == '\0')
			continue;
		fprintf(fd, "%s = %s\n", settings[i].key, settings[i].value);
	}
	fclose(fd);
}

void WriteConfigString(char* target)
{
	int i;
	for (i = 0; i < MAXSETTINGS; i++)
	{
		if (settings[i].key[0] == '\0')
			break;
		if (settings[i].value[0] == '\0')
			continue;
		strcat(target, settings[i].key);
		strcat(target, " = ");
		strcat(target, settings[i].value);
		strcat(target, "\r\n");
	}
}

void DetermineDefaults()
{
	int i;
#define DETERMINE(key, firstDrv, lastDrv) \
	SetSetting(defaults, (char*)key, 0); \
	for (i = firstDrv; i <= lastDrv; i++) \
	{ \
		if (!(drivers[i].flags & 1)) continue; \
		if (!driverAvailable[i]) continue; \
		if (!driverSupported[i]) continue; \
		SetSetting(defaults, (char*)key, (char*)drivers[i].file); \
		break; \
	}
	DETERMINE("videoDrv", vga320, hercmono);
	DETERMINE("soundDrv", mtpro, midnone);
	DETERMINE("audioDrv", audps1, audnone);
#ifndef NOJOY
	SetSetting(defaults, "joyDrv", "NO");
	SetSetting(defaults, "kbdDrv", "IBMKBD.DRV");
	SetSetting(defaults, "mouseDrv", "STDMOUSE.DRV");
	DETERMINE("memoryDrv", arm, nomemory);
#else
	SetSetting(defaults, "joyDrv", "NO");
	SetSetting(defaults, "kbdDrv", "IBMKBD.DRV");
	SetSetting(defaults, "mouseDrv", "STDMOUSE.DRV");
	SetSetting(defaults, "memoryDrv", "ARM.DRV");
#endif
#undef DETERMINE
}

const char* defaultKeys[] =
{
	"videoDrv", "soundDrv", "audioDrv",
	"joyDrv", "kbdDrv", "mouseDrv", "memoryDrv"
};

int IsDefaults()
{
	int i;
	for (i = 0; i < 7; i++)
		if (stricmp(
			GetSetting(settings, (char*)defaultKeys[i], 0),
			GetSetting(defaults, (char*)defaultKeys[i], 0)))
			return 0;
	return 1;
}

void ResetToDefaults()
{
	int i;

	for (i = 0; i < 7; i++)
		SetSetting(settings, (char*)defaultKeys[i], GetSetting(defaults, (char*)defaultKeys[i], 0));
	SetSetting(settings, "minHunk", "220k");
}

void FallBackToDefaults()
{
	int i;
	struct ffblk ff;
	char* drv, *key;
	for (i = 0; i < 5; i++)
	{
		key = (char*)defaultKeys[i];
		drv = GetSetting(settings, key, 0);
		if (!stricmp(drv, "NO"))
			continue;
		if (findfirst(drv, &ff, 0))
			SetSetting(settings, key, GetSetting(defaults, key, 0));
	}
}

/*********************************************************
 * INSTALL implementation
 *********************************************************/
int installMode = 0;

char* targetDisk = "C";
char* sourceDisk = "D";
char targetPath[250];
char resCfgAsString[1024] = { 0 };

int RunScriptLine(char* line);
int pick(char* keys);
void Expand(char* from, char* to);
char* Trim(char* s);
int ScriptPrintf(char* format, ...);
int ScriptAlertf(char* format, ...);

FILE* scriptFile;
int scriptLine;
int errorLevel;
//window:  10, 3, 70, 18
//content: 12, 4, 66, 16
//             |_________ add to scriptLine

int ScriptAlert(char* rol);
int ScriptChDir(char* rol);
int ScriptClear(char* rol);
int ScriptCopy(char* rol);
int ScriptDel(char* rol);
int ScriptEcho(char* rol);
int ScriptEnd(char* rol);
int ScriptExists(char* rol);
int ScriptGoDir(char* rol);
int ScriptGoto(char* rol);
int ScriptIf(char* rol);
int ScriptPause(char* rol);
int ScriptPick(char* rol);
int ScriptRem(char* rol);
int ScriptSpace(char* rol);
int ScriptTestDir(char* rol);

#pragma argsused
int ScriptRemark(char* rol) { return 0; }

typedef struct scriptCommand
{
	char* token;
	int(*handler)(char*);
} scriptCommand;
const scriptCommand scriptCommands[] =
{
	{ ";", ScriptRemark },
	{ "rem", ScriptRemark },
	{ "/*", ScriptRemark },
	{ "//", ScriptRemark },

	{ "alert", ScriptAlert },
	{ "cd", ScriptChDir },
	{ "clear", ScriptClear },
	{ "cls", ScriptClear },
	{ "copy", ScriptCopy },
	{ "del", ScriptDel },
	{ "echo", ScriptEcho },
	{ "end", ScriptEnd },
	{ "exists", ScriptExists },
	{ "godir", ScriptGoDir },
	{ "goto", ScriptGoto },
	{ "if", ScriptIf },
	{ "pause", ScriptPause },
	{ "pick", ScriptPick },
	{ "space", ScriptSpace },
	{ "testdir", ScriptTestDir },

	{ 0, 0 }
};
const char* scrSeps = " \t";

/*
%1	target drive	C
%2	source drive	D
%3	resource.cfg contents
%4	target path		\SIERRA\KQ6CDL
*/

int ScriptAlert(char* rol)
{
	int i = Message(rol, 0, CONFIRM_COLOR | MESSAGE_ENTERORESC);
	if (i == 27)
		return 1;
	return 0;
}

int ScriptChDir(char* rol)
{
	chdir(rol);
	return 0;
}

#pragma argsused
int ScriptClear(char* rol)
{
	int top, left;
	for (top = 4; top < 20; top++)
		for (left = 12; left < 66; left++)
			vidya[((top * 80) + left) * 2] = ' ';
	scriptLine = 0;
	return 0;
}

int ScriptCopy(char* rol)
{
	char from[128] = { 0 };
	char to[128] = { 0 };
	char also[128] = { 0 };
	char cwd[250];
	int done = 0;
	struct ffblk found;
	char drive[3], dir[MAXDIR], file[10], ext[6];
	const char* fullPath = "%s%s%s%s";
	int noTo = 0;
	char fromnow[128], tonow[128];
	char fdrive[3], fdir[MAXDIR], ffile[10], fext[6];
	char tdrive[3], tdir[MAXDIR], tfile[10], text[6];
	char copyBuf[512];
	FILE *source, *target;
	int cnt;

	rol = gettok(rol, from, scrSeps, 128);
	if (*rol)
	{
		rol = gettok(rol, to, scrSeps, 128);
		if (strlen(to) == 1 && to[0] == '+')
		{
			rol = gettok(rol, also, scrSeps, 128);
			to[0] = 0;
		}
		if (*rol)
		{
			rol = gettok(rol, to, scrSeps, 128);
		}
	}

	getcwd(cwd, 250);
	if (cwd[strlen(cwd)] != '\\')
	{
		cwd[strlen(cwd)+1] = 0;
		cwd[strlen(cwd)] = '\\';
	}

	if (!*from)
	{
		Message(TEXT_SCRIPT_NO_COPY_FROM, TEXT_SCRIPT_ERROR, 7);
		return 1;
	}

	if (strchr(from, '*'))
	{
		done = findfirst(from, &found, 0);
		while (!done)
		{
			fnsplit(from, drive, dir, file, ext);
			sprintf(also, "%s%s%s %s", drive, dir, found.ff_name, to);
			ScriptCopy(also);
			done = findnext(&found);
		}
	}
	else if (!*also)
	{
		if (!*to)
		{
			sprintf(to, "%c:", cwd[0]);
			noTo = 1;
		}
		fnsplit(from, fdrive, fdir, ffile, fext);
		sprintf(fromnow, fullPath, fdrive, fdir, ffile, fext);
		strtoupper(fromnow);
		fnsplit(to, tdrive, tdir, tfile, text);
		if (tdir[0] == 0) strcpy(tdir, fdir);
		if (tfile[0] == 0) strcpy(tfile, ffile);
		if (text[0] == 0) strcpy(text, fext);
		sprintf(tonow, fullPath, tdrive, tdir, tfile, text);
		strtoupper(tonow);

		if (noTo)
			ScriptPrintf(TEXT_SCRIPT_COPYING, fromnow);
		else
			ScriptPrintf(TEXT_SCRIPT_COPYINGTO, fromnow, tonow);

		source = fopen(fromnow, "rb");
		if (source == 0) return ScriptAlertf(TEXT_SCRIPT_CANTFINDINPUT, fromnow);
		target = fopen(tonow, "wb");
		if (target == 0) return ScriptAlertf(TEXT_SCRIPT_CANTMAKEOUTPUT, tonow);
		while ((cnt = fread(copyBuf, 1, 512, source)) != 0)
			fwrite(copyBuf, 1, cnt, target);
		fclose(source);
		fclose(target);
	}
	else
	{
		strtoupper(also);
		strtoupper(from);
		ScriptPrintf(TEXT_SCRIPT_ADDINGTO, also, from);
		//printf("Non-wildcard append...\n");
		source = fopen(also, "rb");
		if (source == 0) return ScriptAlertf(TEXT_SCRIPT_CANTFINDINPUT, also);
		target = fopen(from, "ab");
		if (target == 0) return ScriptAlertf(TEXT_SCRIPT_CANTOPENOUTPUT, from);

		while ((cnt = fread(copyBuf, 1, 512, source)) != 0)
			fwrite(copyBuf, 1, cnt, target);
		fclose(source);
		fclose(target);
	}
	return 0;
}

int ScriptDel(char* rol)
{
	struct ffblk found;
	int done = findfirst(rol, &found, 0);
	while (!done)
	{
		unlink(found.ff_name);
		done = findnext(&found);
	}
	return 0;
}

int ScriptEcho(char* rol)
{
	char* pipe = strchr(rol, '>');
	char* mode = "wt";
	FILE* output;

	if (pipe == 0)
	{
		//Plain echo to screen.
		ScriptPrintf(rol);
		return 0;
	}
	*pipe = '\0';
	pipe++;
	if (*pipe == '>')
	{
		mode = "at";
		pipe++;
	}
	output = fopen(pipe, mode);
	fputs(rol, output);
	fputc('\n', output);
	fclose(output);
	return 0;
}

#pragma argsused
int ScriptEnd(char* rol)
{
	return 1;
}

int ScriptExists(char* rol)
{
	//Check for file's existance. If it doesn't exist, produce message, wait for key, and repeat.
	//exists <file> <message>
	//exists %2:resource.p01 Please insert the disk labeled "Disk 1" in drive %2:.
	struct ffblk ff;
	char tok[128];
	rol = gettok(rol, tok, scrSeps, 128);
	while(findfirst(tok, &ff, 0))
	{
		sound(1300); delay(250); nosound();
		if (ScriptAlert(rol))
			return 1;
	}
	return 0;
}

int ScriptGoDir(char* rol)
{
	int first = 1;
	char tok[32];
	char* space = strchr(rol, ' ');
	char* failLabel = space + 1;
	char cwd[250];
	const char* root = "\\";
	*space = '\0';
	while(rol < space)
		{
		rol = gettok(rol, tok, root, 64);
		//printf("> \"%s\"\n", tok);
		if (first)
		{
			setdisk(tok[0] - 'A');
			chdir(root);
			first--;
			//getcwd(cwd, 250); //printf("CWD is now %s.\n", cwd);
			continue;
		}
		errno = 0;
		mkdir(tok); //if (mkdir(tok) < 0) break;
		//errno = 2; break;
		if (chdir(tok) < 0) break;
		getcwd(cwd, 250); //printf("CWD is now %s.\n", cwd);
	}
	if (errno == 2) //ENOENT
		return ScriptGoto(failLabel);
	return 0;
}

int ScriptGoto(char* rol)
{
	char line[512];
	char* str;
	fseek(scriptFile, 0, 0); //SEEK_SET
	while (fgets(line, sizeof(line), scriptFile))
	{
		str = Trim(line);
		if (strlen(str) == 0) continue;
		if (str[0] != ':') continue;
		str++;
		if (!stricmp(rol, str))
			return 0;
	}
	return 1;
}

int ScriptIf(char* rol)
{
	//if [not] (errorlevel <value>) <command>
	//if [not] exist <file> <command>
	char tok[128];
	struct ffblk ff;
	rol = gettok(rol, tok, scrSeps, 128);
	if (!stricmp(tok, "errorlevel"))
	{
		Message(TEXT_SCRIPT_NO_ERRORLEVEL, TEXT_SCRIPT_ERROR, 7);
		return 0;
	}
	if (!stricmp(tok, "exist"))
	{
		rol = gettok(rol, tok, scrSeps, 128);
		if (!findfirst(tok, &ff, 0))
			return RunScriptLine(rol);
	}
	//RunScriptLine(rol)
	return 0;
}

#pragma argsused
int ScriptPause(char* rol)
{
	ScriptPrintf(TEXT_SCRIPT_PRESSANYKEY);
 	getch();
	return 0;
}

int ScriptPick(char* rol)
{
	//pick ls large small
	int i, numKeys;
	char* keys = rol;
	char* labels[10];
	rol = strchr(rol, ' ');
	*rol++ = '\0';
	numKeys = strlen(keys);
	//printf("keys: \"%s\" (%d), rol: \"%s\".\n", keys, numKeys, rol);
	for (i = 0; i < numKeys; i++)
	{
		labels[i] = rol;
		rol = strchr(rol, ' ');
		*rol++ = '\0';
		//printf("%d. \"%s\"\n", i, labels[i]);
	}
	//printf("Your choice: %s\n", labels[j]);
	return ScriptGoto(labels[pick(keys)]);
}

int ScriptSpace(char* rol)
{
	struct diskfree_t df;
	unsigned long available, wanted;
	unsigned char drive;
	char* failLabel;

	//SPACE <drive> <label>
	//IN KILOBYTES
	if (GetSetting(settings, "space", 0))
	{
		Message(TEXT_SCRIPT_DOUBLE_SPACE, TEXT_SCRIPT_ERROR, CONFIRM_COLOR);
		return 1;
	}
	drive = *rol - 'A' + 1;
	rol = strchr(rol, ' ') + 1;
	wanted = strtoul(rol, &rol, 10);
	failLabel = strchr(rol, ' ') + 1;
	_dos_getdiskfree(drive, &df);
	available = (unsigned long)df.avail_clusters
			  * (unsigned long)df.bytes_per_sector
			  * (unsigned long)df.sectors_per_cluster;
	//printf("SPACE: %ld available on %c:, %ld  wanted, fail to %s.\n", available, drive + 'A' - 1, wanted, failLabel);
	if (available < wanted)
		return ScriptGoto(failLabel);
	return 0;
}

#pragma argsused
int ScriptTestDir(char* rol)
{
	//TODO: check for anything in path, warn and ask if okay to continue.
	//Return 1 on NO.
	/*"Directory %s found with existing files!


In order to ensure a proper install, please remove all the Sierra files from this directory

Do you wish to continue with install?" */
	Message("TODO: TESTDIR", 0, 7);
	return 0;
}

int pick(char* keys)
{
	int i, n = strlen(keys);
	char k;
	while (1)
	{
		k = getch();
		if (k >= 'A' && k <= 'Z')
			k = k - 'A' + 'a';
		for (i = 0; i < n; i++)
		{
			if (k == keys[i])
				return i;
		}
	}
}

void Expand(char* from, char* to)
{
	while (*from)
	{
		if (*from == '%')
		{
			from++;
			if (*from >= '1' && *from <= '4')
			{
				switch (*from)
				{
					case '1': strcat(to, targetDisk); break;
					case '2': strcat(to, sourceDisk); break;
					case '3': strcat(to, resCfgAsString); break;
					case '4': strcat(to, targetPath); break;
				}
				from++;
				to += strlen(to);
			}
		}
		else
		{
			*to++ = *from++;
		}
	}
}

char* Trim(char* s)
{
	char * end;
	for (; isspace(*s); s++) ;
	for (end = s; *end; end++) ;
	for (end--; isspace(*end); *end-- = '\0') ;
	return s;
}

int ScriptAlertf(char* format, ...)
{
	char buffer[80];
	va_list argptr;
	va_start(argptr, format);
	vsprintf(buffer, format, argptr);
	va_end(argptr);
	return ScriptAlert(buffer);
}

int ScriptPrintf(char* format, ...)
{
	char buffer[80];
	va_list argptr;
	int count, top, left, i;
	va_start(argptr, format);
	count = vsprintf(buffer, format, argptr);
	va_end(argptr);

	//printf(buffer);
	Text(12, 4 + scriptLine, buffer);
	scriptLine++;
	if (scriptLine == 16)
	{
		scriptLine--;
		for (top = 4; top < 19; top++)
		{
			for (left = 12; left < 66; left++)
			{
				i = ((top * 80) + left) * 2;
				vidya[i] = vidya[i + 160];
			}
		}
		for (left = 12; left < 66; left++)
			vidya[((19 * 80) + left) * 2] = ' ';
	}

	return count;
}

void DetectInstallMode()
{
	unsigned int disk, cd, mscdex;

	//Get current disk #
	asm {
		mov ah, 0x19
		int 0x21
		xor ah, ah
		mov disk, ax
	}

	sourceDisk[0] = disk + 'A';

	if (disk >= 2)
	{
		installMode = 0;
		//but wait, wait if it's a CD-ROM?
		asm {
			mov cx, disk
			mov ax, 0x150B
			int 2Fh
			mov cd, ax
			mov mscdex, bx
		}
		if (mscdex == 0xADAD && cd != 0)
			installMode = 1;
	}

	if (installMode)
	{
		FILE* scrFile = fopen(SCRIPT, "r");
		if (scrFile != 0)
		{
			fclose(scrFile);
			installMode = 2;
		}
	}
}

#pragma warn -par
void far AbortRetryJustFail(unsigned int deverr, unsigned int errval, unsigned far int* devhdr)
{
	if (deverr & 0x8000)
		_hardretn(5);
	//Detect the disk space thing and actually DO ask to abort/retry/fail if it's not that?
	_hardresume(_HARDERR_FAIL);
}
#pragma warn +par

int SelectTargetDisk()
{
	int i, j;
	long wanted = 0, last = 0;
	float space;
	char text[26][32];
	struct diskfree_t df;
	menuList* list;
	char* spaceSetting = GetSetting(settings, "space", 0);
	if (spaceSetting) wanted = atol(spaceSetting);
	list = (menuList*)calloc(sizeof(menuList), 1);
	list->title = TEXT_SELECT_DRIVE_TITLE;
	list->headText = TEXT_SELECT_DRIVE;
	list->count = 0;
	_harderr(AbortRetryJustFail);
	for (i = 0; i < 18; i++) //use 2 to skip to C:
	{
		//TODO: find some way to determine if this drive has missing media.

		if (_dos_getdiskfree(i+1, &df))
			continue; //invalid drive
		space = ( (unsigned long)df.avail_clusters
				* (unsigned long)df.bytes_per_sector
				* (unsigned long)df.sectors_per_cluster
				) / 1024.0;
		last = (long)(space);

		if (df.avail_clusters == 0)
			continue; //presume it's a CD-ROM or whatever.
		if (last < wanted)
			continue;
		sprintf(text[list->count], TEXT_SELECT_DRIVE_FORMAT, i + 'A', space / 1024);
		list->items[list->count] = text[list->count];
		list->keys[list->count] = i;
		list->count++;
	}
	if (list->count == 0)
	{
		Message(TEXT_SELECT_DRIVE_NOSPACE, TEXT_SELECT_DRIVE_TITLE, CONFIRM_COLOR);
		Exit(1);
	}
	ClearScreen();
	i = DoMenu(list);
	if (i != -1)
		targetDisk[0] = list->keys[i] + 'A';
	ClearScreen();
	return i;
}

char* truename(char* dst, char* src)
{
	union REGS rg;
	struct SREGS rs;
	if (!src || !*src || !dst) return NULL;
	src = Trim(src);
	rg.h.ah = 0x60;
	rg.x.si = FP_OFF(src);
	rg.x.di = FP_OFF(dst);
	rs.ds = FP_SEG(src);
	rs.es = FP_SEG(dst);
	intdosx(&rg,&rg,&rs);
	return (rg.x.cflag) ? NULL : dst;
}

void SelectTargetPath()
{
	//targetPath
	/* Enter directory will game will be installed
	 *
	 *  Directory #:\_____________________________
	 */
	int i, y;
	char len;
	char buffer[250];
	char cancelPath[250];

	strcpy(cancelPath, targetPath);
	if (targetPath[0] == 0)
		targetPath[0] = '\\';

	sprintf(buffer, TEXT_SELECT_DIR_PROMPT, targetDisk);

	Window(10, 10, 60, 6, TEXT_SELECT_DIR_TITLE, MENU_COLOR);
	Text(13, 12, TEXT_SELECT_DIR);
	Text(14, 14, buffer);
	y = 14 + strlen(buffer);
	SetAttr(y + 1, 14, 40, 0x0F);

	while(1)
	{
		Text(y, 14, targetPath);
		len = y + strlen(targetPath);
		//show cursor
		asm {
			mov ah, 2
			xor bh, bh
			mov dh, 14
			mov dl, len
			int 0x10
		}
		len -= y;
		i = getch();
		if (!i)
			getch();
		else if (i == 27) //escape
		{
			strcpy(targetPath, cancelPath);
			break;
		}
		else if (i == 13) //enter
		{
			sprintf(buffer, "%s:%s", targetDisk, targetPath);
			truename((char far*)buffer, (char far*)buffer);
			strcpy(targetPath, buffer + 2);
			break;
		}
		else if (i == 8 && len > 1) //backspace
		{
			Text(y + len - 1, 14, " ");
			targetPath[len - 1] = 0;
		}
		else if (i >= 32 && i < 127 && len < 40)
		{
			targetPath[len] = i;
			targetPath[len+1] = 0;
		}
	}
	HideCursor();
}

int RunScriptLine(char* line)
{
	char token[256];
	int ret, t;
	char* str;
	FILE* redirFile;

	str = gettok(line, token, scrSeps, 256);
	str = Trim(str);
	ret = -1;
	for (t = 0; scriptCommands[t].token; t++)
	{
		if (!stricmp(scriptCommands[t].token, token))
		{
			ret = scriptCommands[t].handler(str);
			break;
		}
	}
	if (ret == -1)
	{
		//TODO: try shelling out for unknown commands like auddcomp and havevesa.
		//printf("Unknown command \"%s\".\n", token);
		//ret = 1;
		//ScriptAlertf("Shelling out for \"%s\".", line);
		sprintf(line, "%s > redir.$$$", line);
		//errorLevel = spawnl(P_WAIT, line, 0);
		errorLevel = system(line); //TODO
		redirFile = fopen("redir.$$$", "r");
		while(fgets(line, sizeof(line), redirFile))
			ScriptPrintf(line);
		fclose(redirFile);
		unlink("redir.$$$");
		ret = abs(errorLevel);
		//ret = abs(system(line));
	}
	return ret;
}

void RunDefaultScript()
{
	char line[512];
	sprintf(line, "godir %s:%s cantcreate", targetDisk, targetPath);
	if (RunScriptLine(line))
	{
		ScriptAlertf("alert Unable to create directory %s:%s", targetDisk, targetPath);
		return;
	}
	sprintf(line, "echo %s>resource.cfg", resCfgAsString); RunScriptLine(line);
	sprintf(line, "copy %s:install.exe", sourceDisk); RunScriptLine(line);
	sprintf(line, "copy %s:*.drv", sourceDisk); RunScriptLine(line);
	sprintf(line, "copy %s:resource.000", sourceDisk); RunScriptLine(line);
	sprintf(line, "copy %s:resource.map", sourceDisk); RunScriptLine(line);
	sprintf(line, "copy %s:resource.sfx", sourceDisk); RunScriptLine(line);
	sprintf(line, "if exist %s:resource.aud copy %s:resource.aud", sourceDisk, sourceDisk); RunScriptLine(line);
	sprintf(line, "copy %s:sierra.exe", sourceDisk); RunScriptLine(line);
	RunScriptLine("echo Installation complete.");
	RunScriptLine("pause");
}

void RunScript()
{
	int ret, i;
	char line[512], expanded[512];
	char* str;

	WriteConfigString(resCfgAsString);

	Window(10, 3, 60, 18, 0, 0x78);
	for (i = 4; i < 19; i++)
		SetAttr(12, i, 56, 0x70);
	scriptLine = 0;


	if (installMode == 1)
	{
		RunDefaultScript();
		return;
	}

	scriptFile = fopen(SCRIPT, "rt");
	while (fgets(line, sizeof(line), scriptFile))
	{
		for (i = 0; i < sizeof(expanded); i++) { expanded[i] = '\0'; }
		str = Trim(line);
		if (strlen(str) == 0) continue;
		if (str[0] == ':') continue;
		Expand(str, expanded);
		ret = RunScriptLine(expanded);
		for (i = 0; i < sizeof(line); i++) { line[i] = expanded[i] = '\0'; }
		if (ret)
			break;
	}
	fclose(scriptFile);
}


/*********************************************************
 * MAIN implementation
 *********************************************************/

void MainMenu()
{
	int i, j, warnsSet = 0;
	char *current;
	char text[12][64];
#ifdef LANGUAGEPACKS
	int langs = 0;
	char *langCode, *langFound;
	DIR* langDir;
#endif
	menuList* list = (menuList*)calloc(sizeof(menuList), 1);

	list->title = TEXT_MAINMENU_CAPTION;
	list->headText = TEXT_MAINMENU;

#ifdef LANGUAGEPACKS
	langDir = opendir("lang");
	if (langDir != 0)
	{
		langs = 1;
		closedir(langDir);
	}
#endif

	while(1)
	{
		list->count = 0;

		strcpy(text[0], TEXT_MAINMENU_GRAPHICS);
		current = GetSetting(settings, "videoDrv", 0); //"vga320.drv");
		for (j = 0, i = vga320; i <= hercmono; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = vga320; i <= hercmono; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[0] = drivers[i].warning;
					strcat(text[0], drivers[i].name);
				}
			list->items[list->count] = text[0];
			list->keys[list->count] = 0;
			list->count++;
		}

		strcpy(text[1], TEXT_MAINMENU_MUSIC);
		current = GetSetting(settings, "soundDrv", 0); //"mt32.drv");
		for (j = 0, i = mtpro; i <= midnone; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = mtpro; i <= midnone; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[1] = drivers[i].warning;
					strcat(text[1], drivers[i].name);
				}
			list->items[list->count] = text[1];
			list->keys[list->count] = 1;
			list->count++;
		}

		strcpy(text[2], TEXT_MAINMENU_AUDIO);
		current = GetSetting(settings, "audioDrv", 0); //"audblast.drv");
			for (j = 0, i = audps1; i <= audnone; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = audps1; i <= audnone; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[2] = drivers[i].warning;
					strcat(text[2], drivers[i].name);
				}
			list->items[list->count] = text[2];
			list->keys[list->count] = 2;
			list->count++;
		}

#ifndef NOJOY
		strcpy(text[3], TEXT_MAINMENU_JOYSTICK);
		current = GetSetting(settings, "joyDrv", 0); //"no");
		for (j = 0, i = joystick; i <= nojoy; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = joystick; i <= nojoy; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[3] = drivers[i].warning;
					strcat(text[3], drivers[i].name);
				}
			list->items[list->count] = text[3];
			list->keys[list->count] = 3;
			list->count++;
		}

		strcpy(text[4], TEXT_MAINMENU_KEYBOARD);
		current = GetSetting(settings, "kbdDrv", 0); //"ibmkbd.drv");
		for (j = 0, i = ibmkbd; i <= tandykbd; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = ibmkbd; i <= tandykbd; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[4] = drivers[i].warning;
					strcat(text[4], drivers[i].name);
				}
			list->items[list->count] = text[4];
			list->keys[list->count] = 4;
			list->count++;
		}

		strcpy(text[5], TEXT_MAINMENU_MOUSE);
		current = GetSetting(settings, "mouseDrv", 0); //"stdmouse.drv");
		for (j = 0, i = stdmouse; i <= nomouse; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = stdmouse; i <= nomouse; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[5] = drivers[i].warning;
					strcat(text[5], drivers[i].name);
				}
			list->items[list->count] = text[5];
			list->keys[list->count] = 5;
			list->count++;
		}

		strcpy(text[6], TEXT_MAINMENU_MEMORY);
		current = GetSetting(settings, "memoryDrv", 0); //"arm.drv");
		for (j = 0, i = arm; i <= nomemory; i++)
			if (driverAvailable[i]) j++;
		if (j > 1)
		{
			for (i = arm; i <= nomemory; i++)
				if (stricmp(drivers[i].file, current) == 0)
				{
					if (!warnsSet) driverWarnings[6] = drivers[i].warning;
					strcat(text[6], drivers[i].name);
				}
			list->items[list->count] = text[6];
			list->keys[list->count] = 6;
			list->count++;
		}
#endif

#ifdef LANGUAGEPACKS
		if (langs)
		{
			strcpy(text[7], TEXT_MAINMENU_LANGUAGE);
			current = GetSetting(settings, "patchDir", ".");
			langCode = "en";
			langFound = strstr(current, "lang\\");
			if (langFound != 0)
			{
				langCode = langFound + 5; //skip over to lang code
				langCode[2] = 0; //ensure two-letter code;
			}
			for (i = 0; i < NUMLANGS; i++)
				if (stricmp(languages[i].code, langCode) == 0)
					strcat(text[7], languages[i].name);
			list->items[list->count] = text[7];
			list->keys[list->count] = 7;
			list->count++;
		}
#endif

		if (installMode)
		{
			sprintf(text[8], TEXT_MAINMENU_DIRECTORY, targetDisk[0], targetPath);
			list->items[list->count] = text[8];
			list->keys[list->count] = 13;
			list->count++;
		}

		warnsSet = 1;

		list->items[list->count++] = ""; //yes.

		if (haveReadme)
		{
			list->items[list->count] = TEXT_MAINMENU_README;
			list->keys[list->count++] = 8;
		}
		list->active = list->count;
		if (haveReadme == 2)
			list->active--;

		if (installMode)
		{
			list->items[list->count] = TEXT_MAINMENU_INSTALL;
			list->keys[list->count++] = 12;
		}
		else
		{
			list->items[list->count] = TEXT_MAINMENU_ACCEPT;
			list->keys[list->count++] = 9;
		}
		if (!IsDefaults())
		{
			list->items[list->count] = TEXT_MAINMENU_DEFAULT;
			list->keys[list->count++] = 10;
		}
		list->items[list->count] = TEXT_MAINMENU_CANCEL;
		list->keys[list->count++] = 11;

		ClearScreen();
		i = DoMenu(list);
		if (i == -1)
			i = list->count - 1;
		switch(list->keys[i])
		{
			case 0: SelectVideo(); break;
			case 1: SelectMusic(); break;
			case 2: SelectAudio(); break;
#ifndef NOJOY
			case 3: SelectJoystick(); break;
			case 4: SelectKeyboard(); break;
			case 5: SelectMouse(); break;
			case 6: SelectMemory(); break;
#endif
#ifdef LANGUAGEPACKS
			case 7: SelectLanguage(); break;
#endif
			case 8:	ViewFile(readmeFile); haveReadme = 1; break;
			case 9: DoWarnings(); WriteConfigFile(); free(list); Exit(0); break;
			case 10: ResetToDefaults(); break;
			case -1:
			case 11:
				i = Message(TEXT_EXIT, 0, MESSAGE_YESORNO | CONFIRM_COLOR);
				if (i == 'y' || i == 13)
				{
					free(list);
					Exit(0);
				}
				break;
			case 12: DoWarnings(); RunScript(); free(list); Exit(0); break;
			case 13: if (SelectTargetDisk() != -1) SelectTargetPath(); break;
		}
	}
}

void strtoupper(char* str)
{
	while(*str)
		*str++ = toupper(*str);
}

void HideCursor()
{
	//put cursor off-screen (row 0-24, put it on 25)
	asm {
		mov ah, 2 //set cursor position
		xor bh, bh //page 0
		mov dh, 25 //row 25
		xor dl, dl //column 0
		int 0x10
	}
}

void SetupScreen()
{
	//reset to 80x25, just in case
	asm {
		mov ah, 0 //set video mode
		mov al, 3 //textmode, 80x25
		int 0x10
	}

#ifdef NORTON
	if (VGALevel >= 1)
	{
		//enable bright background colors
		asm {
			mov ax, 0x1003 //set block specifier
			mov bl, 00h
			int 0x10
		}
	}
#endif

#ifdef NORTON
	if (VGALevel >= 1) //Not enough space on EGA lines to make it look good, and CGA won't do it at all.
	{
		//force 8-pixel cells
		outportb(0x3C4, 0x01); //Clocking Mode
		outportb(0x3C5, 0x01); //8-Dot Mode

		FuckUpFont();
	}
#endif

	HideCursor();
}

void main(int argc, char* argv[])
{
	int i;
	int noIntro = 0, forceCGA = 0;

	DetectInstallMode();

	for (i = 1; i < argc; ++i)
	{
		if (*argv[i] != '-')
		{
			strcpy(resCfg, argv[i]);
			strtoupper(resCfg);
		}
		else
		{
			++(argv[i]);
			switch (*argv[i])
			{
				case 'i'://nstall mode
					installMode = 1;
					break;
				case 'I'://nstall mode
					installMode = 2;
					break;
				case 'n'://o intro
					noIntro = 1;
					break;
				case 'r'://eset
					CheckDrivers();
					CheckSupport();
					DetermineDefaults();
					ResetToDefaults();
					WriteConfigFile();
					printf(TEXT_RESTOREDDEFAULTS, resCfg);
					return;
#ifndef MEINLEBEN
				case 's'://kip soundblaster
					skipSBDetect = 1;
					break;
#endif
				case 'f'://orce cga
					forceCGA = 1;
					break;
				default:
					printf(TEXT_USAGE);
					return;
			}
		}
	}

	CheckDrivers();
	CheckSupport();
	DetermineDefaults();
	if (forceCGA == 1) VGALevel = 0;
	SetupScreen();
	ClearScreen();
	ReadConfigFile();
	//FallBackToDefaults();

	if (!noIntro)
	{
		if (Message(TEXT_INTRO, TEXT_INTRO_CAPTION, MESSAGE_COLOR) == 27)
			Exit(0);
	}

	if (installMode)
	{
		if (SelectTargetDisk() == -1)
			Exit(0);
		strcpy(targetPath, GetSetting(settings, "directory", 0));
		if (targetPath == 0 || targetPath[0] == '\0')
			SelectTargetPath();
	}
	MainMenu();

	//disabling bright background colors is done by clrscr, it seems.
	Exit(0);
}

void Exit(int ret)
{
	asm {
		mov ah, 0
		mov al, 3
		int 0x10
	};
	exit(ret);
}
